﻿Imports System
Imports System.IO
'Imports System.Windows.Forms
Imports System.Text
Imports System.Globalization
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Imaging
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Neu
Imports NM_Ahnen.cls_02_DB_Import_GM
Imports NM_Ahnen.cls_02_DB_Import_GedCom
Imports NM_Ahnen.cls_02_DB_Export_GedCom
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.cls_03_DB_Person_Delete
Imports NM_Ahnen.cls_03_DB_Person_Neu
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.cls_03_DB_Bilder
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.cls_09_Koeln
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_10_Mask
Imports NM_Ahnen.cls_10_Mask_14
Imports NM_Ahnen.cls_20_Blaettern
Imports NM_Ahnen.cls_30_Search
Imports NM_Ahnen.cls_40_Print_Vorfahren
Imports NM_Ahnen.cls_40_Print_Nachfahren
Imports NM_Ahnen.cls_50_Daten_14
Imports NM_Ahnen.Cls_60_Info

Public Class NM_Ahnen
    Inherits System.Windows.Forms.Form
    Public ReadOnly Preview As New PreviewHandler

    REM *----------------------------------------------------------------*
    REM *  Programm auf deutsche Kultur festlegen (Datumsformat          *
    REM *----------------------------------------------------------------*
    Public Shared WithEvents MCM As CurrencyManager
    REM **************************************************************
    REM *  Hauptprogramm                                             *
    REM **************************************************************
    Private Sub NM_Ahnen_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Preview.PreviewWindow = pbx_01_01
        dt.ToString("d", ci)
        str_AktJahr = dt.Year.ToString("0000")
        str_AktMon = dt.Month.ToString("00")
        str_AktTag = dt.Day.ToString("00")
        str_AktHH = dt.Hour.ToString("00")
        str_AktMM = dt.Minute.ToString("00")
        str_AktSS = dt.Second.ToString("00")
        str_AktDat = str_AktTag + str_AktMon + str_AktJahr
        str_AktDat1 = str_AktDat + str_AktHH + str_AktMM + str_AktSS
        str_AktDatP = str_AktTag + "." + str_AktMon + "." + str_AktJahr
        int_Sort_Merk = 0
        int_Info_Type = 1
        NM_Ahnen_Info.Show()

        Me.pan_OK.Visible = False
        Call Load_INI()
        Call Mask_Pos()
        str_LogFile = str_Directory + "/LogFile" + ".txt"
        Using sw As StreamWriter = File.CreateText(str_LogFile)
        End Using
        REM *  Maske einblenden und Hinweis auf Laden der Daten anzeigen
        Me.Cursor = Cursors.WaitCursor
        Me.Show()
        For Each a As Control In Me.Controls
            If TypeOf (a) Is TextBox Then
                Dim TBox As TextBox = CType(a, TextBox)
                AddHandler TBox.TextChanged, AddressOf TextBoxTextChanged
            End If
        Next
        If int_Total_Error = 1 Then
            Me.Close()
            End
        End If
        Call Open_DB()
        Call Open_Para()

        Call Grundwerte()
        Me.Cursor = Cursors.Hand

        Call Blaettern_First()

        REM * Cursor sichtbarer machen
        Me.Cursor = Cursors.Default
        NM_Ahnen_Info.Close()
        Me.Show()

    End Sub

    Private Sub NM_Ahnen_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Call Parameter_Save()
        End
    End Sub

    Private Sub TextBoxTextChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.pan_OK.Visible = True
    End Sub

    REM ******************************************************************
    REM *  Aufruf der Suchfunktion                                       *
    REM ******************************************************************
    Private Sub Bt_00_Search_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_Search.Click
        int_Merk_STyp = 1
        Call Maskenwechsel_Search()
    End Sub

    REM ******************************************************************
    REM *  Auswahl der Datenbank                                         *
    REM ******************************************************************
    Private Sub Bt_00_DB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_DB.Click
        NM_Ahnen_DB.Show()
    End Sub

    REM ******************************************************************
    REM *  Listenauswahl                                                 *
    REM ******************************************************************
    Private Sub Bt_00_List_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_List.Click

    End Sub

    REM ******************************************************************
    REM *  Wechsel zu Parameter-Maske                                    *
    REM ******************************************************************
    Private Sub Bt_00_Para_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_Para.Click
        Call Maskenwechsel_Para()
    End Sub

    REM ******************************************************************
    REM *  Anzeige der Aufgabenliste                                     *
    REM ******************************************************************
    Private Sub Bt_00_Todo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_Todo.Click
        lng_HID = dbl_ID
        Call Maskenwechsel_ToDo()
    End Sub

    REM ******************************************************************
    REM *  Anzeige der Historiendaten                                    *
    REM ******************************************************************
    Private Sub Bt_00_His_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_His.Click
        Call Maskenwechsel_His()
    End Sub
    REM ******************************************************************
    REM *  Anzeige des Orts-Namensindex                                  *
    REM ******************************************************************
    Private Sub Bt_00_Orte_Click(sender As Object, e As EventArgs) Handles bt_00_Orte.Click
        Call Maskenwechel_Orte()
    End Sub
    REM ******************************************************************
    REM *  Anzeige des Orts-Namensindex                                  *
    REM ******************************************************************
    Private Sub Bt_00_Quelle_Click(sender As Object, e As EventArgs) Handles bt_00_Quelle.Click
        int_QVersion = 0
        int_QuellMask = 1
        Call Maskenwechsel_Quelle()
    End Sub

    REM ******************************************************************
    REM *  Starten der Datenauswahl mit ID                               *
    REM ******************************************************************
    Private Sub Bt_00_ID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_ID.Click
        dbl_ID = Val(Me.tx_00_ID.Text)
        Call Person_Read_01()
    End Sub

    REM **************************************************************
    REM *  Blättermodus bei Personenanzeige                          *
    REM **************************************************************
    Private Sub Bt_00_First_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_First.Click
        Call Blaettern_First()
        Call Tab_Reiter_Neu()
    End Sub

    Private Sub Bt_00_Before_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_Before.Click
        Call Blaettern_Before()
        Call Tab_Reiter_Neu()
    End Sub

    Private Sub Bt_00_Next_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_Next.Click
        Call Blaettern_Next()
        Call Tab_Reiter_Neu()
    End Sub

    Private Sub Bt_00_Last_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_Last.Click
        Call Blaettern_Last()
        Call Tab_Reiter_Neu()
    End Sub

    Private Sub Bt_00_Neu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_Neu.Click
        Call Person_Neu_Init()
    End Sub

    Private Sub Bt_00_Del_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_00_Del.Click
        Call Person_Delete()
    End Sub

    REM **************************************************************
    REM *  Sichtenwechsel Vater                                      *
    REM **************************************************************
    Private Sub Bt_01_Vater_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_01_Vater.Click
        dbl_ID = p_int_Vater
        Call Person_Read_01()
    End Sub

    REM **************************************************************
    REM *  Sichtenwechsel Mutter                                     *
    REM **************************************************************
    Private Sub Bt_01_Mutter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_01_Mutter.Click
        dbl_ID = p_int_Mutter
        Call Person_Read_01()
    End Sub

    REM **************************************************************
    REM *  Info-Aufrufe für Tab 1 (Grunddaten)                       *
    REM **************************************************************
    Private Sub Bt_10_01_Name_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_01_Name.Click
        str_Info01 = "Grunddaten / Name"
        str_InfoTyp = "A" : If p_str_Komm_Name = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 1)
    End Sub
    Private Sub Bt_10_02_GebName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_02_GebName.Click
        str_Info01 = "Grunddaten / Geburtsname"
        str_InfoTyp = "A" : If p_str_Komm_GebName = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 2)
    End Sub
    Private Sub Bt_10_03_NameZ_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_03_NameZ.Click
        str_Info01 = "Grunddaten / Namenszusatz"
        str_InfoTyp = "A" : If p_str_Komm_Name = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 3)
    End Sub

    Private Sub Bt_10_04_Vorname_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_04_Vorname.Click
        str_Info01 = "Grunddaten / Vorname"
        str_InfoTyp = "A" : If p_str_Komm_Vorname = 1 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 4)
    End Sub
    Private Sub Bt_10_05_Rufname_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_05_Rufname.Click
        str_Info01 = "Grunddaten / Rufname"
        str_InfoTyp = "A" : If p_str_Komm_Rufname = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 5)
    End Sub
    Private Sub Bt_10_06_Spitzn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_06_Spitzn.Click
        str_Info01 = "Grunddaten / Spitzname"
        str_InfoTyp = "A" : If p_str_Komm_SpitzN = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 6)
    End Sub
    Private Sub Bt_10_07_Titel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_07_Titel.Click
        str_Info01 = "Grunddaten / Titel"
        str_InfoTyp = "A" : If p_str_Komm_Titel = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 7)
    End Sub
    Private Sub Bt_10_08_GDat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_08_GDat.Click
        str_Info01 = "Grunddaten / Geburtsdatum"
        str_InfoTyp = "A" : If p_str_Komm_GDat = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 8)
    End Sub
    Private Sub Bt_10_09_Geb_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_09_Geb.Click
        str_Info01 = "Grunddaten / Geburtsort"
        str_InfoTyp = "A" : If p_str_Komm_GOrt = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 9)
    End Sub
    Private Sub Bt_10_10_GUrk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_10_GUrk.Click
        str_Info01 = "Grunddaten / Geburtsurkunde"
        str_InfoTyp = "A" : If p_str_Komm_Geb1 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 10)
    End Sub
    Private Sub Bt_10_11_Gurk2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_11_Gurk2.Click
        str_Info01 = "Grunddaten / Geburtsurkunde"
        str_InfoTyp = "A" : If p_str_Komm_Geb2 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 11)
    End Sub
    Private Sub Bt_10_12_SDat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_12_SDat.Click
        str_Info01 = "Grunddaten / Sterbedatum"
        str_InfoTyp = "A" : If p_str_Komm_SDat = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 12)
    End Sub
    Private Sub Bt_10_13_Sterb_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_13_Sterb.Click
        str_Info01 = "Grunddaten / Sterbeort"
        str_InfoTyp = "A" : If p_str_Komm_SOrt = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 13)
    End Sub
    Private Sub Bt_10_14_SUrk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_14_SUrk.Click
        str_Info01 = "Grunddaten / Sterbeurkunde"
        str_InfoTyp = "A" : If p_str_Komm_Sterb1 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 14)
    End Sub
    Private Sub Bt_10_15_SUrk2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_15_SUrk2.Click
        str_Info01 = "Grunddaten / Sterbeurkunde"
        str_InfoTyp = "A" : If p_str_Komm_Sterb2 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(10, 15)
    End Sub

    REM **************************************************************
    REM *  Info-Aufrufe für Tab 2 (Taufe)                            *
    REM **************************************************************
    Private Sub Bt_11_01_Tauf_Dat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_01_Tauf_Dat.Click
        str_Info01 = "Taufdaten / Datum"
        str_InfoTyp = "A" : If p_str_Komm_TDat = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 21)
    End Sub
    Private Sub Bt_11_02_Tauf_Ort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_02_Tauf_Ort.Click
        str_Info01 = "Taufdaten / Ort"
        str_InfoTyp = "A" : If p_str_Komm_TOrt = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 22)
    End Sub
    Private Sub Bt_11_03_Tauf_Kirche_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_03_Tauf_Kirche.Click
        str_Info01 = "Taufdaten / Kirche"
        str_InfoTyp = "A" : If p_str_Komm_TKirch = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 23)
    End Sub
    Private Sub Bt_11_04_Konf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_04_Konf.Click
        str_Info01 = "Taufdaten / Konfession"
        str_InfoTyp = "A" : If p_str_Komm_TKonf = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 24)
    End Sub
    Private Sub Bt_11_05_Priester_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_05_Priester.Click
        str_Info01 = "Taufdaten / Priester"
        str_InfoTyp = "A" : If p_str_Komm_TPriester = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 25)
    End Sub
    Private Sub Bt_11_06_Tauf_Urk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_06_Tauf_Urk.Click
        str_Info01 = "Taufdaten / Urkunde"
        str_InfoTyp = "A" : If p_str_Komm_TUrk = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 26)
    End Sub
    Private Sub Bt_11_08_FDat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_08_FDat.Click
        str_Info01 = "Firmdaten / Datum"
        str_InfoTyp = "A" : If p_str_Komm_FDat = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 31)
    End Sub
    Private Sub Bt_11_09_FOrt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_09_FOrt.Click
        str_Info01 = "Firmdaten / Ort"
        str_InfoTyp = "A" : If p_str_Komm_FOrt = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 32)
    End Sub
    Private Sub Bt_11_10_FKirche_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_10_FKirche.Click
        str_Info01 = "Firmdaten / Kirche"
        str_InfoTyp = "A" : If p_str_Komm_FKirche = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 33)
    End Sub
    Private Sub Bt_11_11_FPriester_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_11_FPriester.Click
        str_Info01 = "Firmdaten / Priester"
        str_InfoTyp = "A" : If p_str_Komm_FPriester = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 34)
    End Sub
    Private Sub Bt_11_13_FUrk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_12_FUrk.Click
        str_Info01 = "Firmdaten / Urkunde"
        str_InfoTyp = "A" : If p_str_Komm_FUrk = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(11, 35)
    End Sub

    REM **************************************************************
    REM *  Info-Aufrufe für Tab 4 (Beerdigung)                       *
    REM **************************************************************
    Private Sub Bt_12_01_BDat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_12_01_BDat.Click
        str_Info01 = "Beerdigung / Datum"
        str_InfoTyp = "A" : If p_str_Komm_BDat = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(12, 41)
    End Sub
    Private Sub Bt_12_02_BOrt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_12_02_BOrt.Click
        str_Info01 = "Beerdigung / Ort"
        str_InfoTyp = "A" : If p_str_Komm_BOrt = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(12, 42)
    End Sub
    Private Sub Bt_12_03_Bart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_12_03_Bart.Click
        str_Info01 = "Beerdigung / Art"
        str_InfoTyp = "A" : If p_str_Komm_BArt = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(12, 43)
    End Sub
    Private Sub Bt_12_09_Priester_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_12_09_Priester.Click
        str_Info01 = "Beerdigung / Priester"
        str_InfoTyp = "A" : If p_str_Komm_BPriester = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(12, 44)
    End Sub
    Private Sub Bt_12_04_Friedhof_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_12_04_Friedhof.Click
        str_Info01 = "Beerdigung / Friedhof"
        str_InfoTyp = "A" : If p_str_Komm_Friedhof = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(12, 45)
    End Sub
    Private Sub Bt_12_05_Grablage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_12_05_Grablage.Click
        str_Info01 = "Beerdigung / Grablage"
        str_InfoTyp = "A" : If p_str_Komm_Grablage = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(12, 46)
    End Sub
    Private Sub Bt_12_06_TodUr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_12_06_TodUr.Click
        str_Info01 = "Beerdigung / Todesursache"
        str_InfoTyp = "A" : If p_str_Komm_TodUrsache = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(12, 47)
    End Sub
    Private Sub Bt_12_07_StUrk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_12_07_StUrk.Click
        str_Info01 = "Beerdigung / Urkunde (Kirche)"
        str_InfoTyp = "A" : If p_str_Komm_BUrk1 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(12, 48)
    End Sub
    Private Sub Bt_12_08_StUrk2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_12_08_StUrk2.Click
        str_Info01 = "Beerdigung / Urkunde (Standesamt)"
        str_InfoTyp = "A" : If p_str_Komm_BUrk2 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(12, 49)
    End Sub

    REM **************************************************************
    REM *  Info-Aufrufe für Tab 5 (Ehe)                              *
    REM **************************************************************
    Private Sub Bt_13_01_Dat1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_01_Dat1.Click
        str_Info01 = "Ehe / Datum Standesamt"
        str_InfoTyp = "A" : If p_str_Komm_EDat1 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 51)
    End Sub
    Private Sub Bt_13_02_Ort1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_02_Ort1.Click
        str_Info01 = "Ehe / Ort Standesamt"
        str_InfoTyp = "A" : If p_str_Komm_EOrt1 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 52)
    End Sub
    Private Sub Bt_13_03_Beamter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_03_Beamter.Click
        str_Info01 = "Ehe / Beamter Standesamt"
        str_InfoTyp = "A" : If p_str_Komm_EBeamt = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 53)
    End Sub
    Private Sub Bt_13_04_Urk1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_04_Urk1.Click
        str_Info01 = "Ehe / Urkunde Standesamt"
        str_InfoTyp = "A" : If p_str_Komm_EUrk1 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 54)
    End Sub
    Private Sub Bt_13_05_TZ1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_05_TZ1.Click
        str_Info01 = "Ehe / Trauzeugen Standesamt"
        str_InfoTyp = "A" : If p_str_Komm_ETZ1 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 55)
    End Sub
    Private Sub Bt_13_06_Dat2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_06_Dat2.Click
        str_Info01 = "Ehe / Datum Kirche"
        str_InfoTyp = "A" : If p_str_Komm_EDat2 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 56)
    End Sub
    Private Sub Bt_13_07_Ort2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_07_Ort2.Click
        str_Info01 = "Ehe / Ort Kirche"
        str_InfoTyp = "A" : If p_str_Komm_EOrt2 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 57)
    End Sub
    Private Sub Bt_13_08_Kirche_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_08_Kirche.Click
        str_Info01 = "Ehe / Kirche"
        str_InfoTyp = "A" : If p_str_Komm_EKirche = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 58)
    End Sub
    Private Sub Bt_13_09_Priester_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_09_Priester.Click
        str_Info01 = "Ehe / Priester Kirche"
        str_InfoTyp = "A" : If p_str_Komm_EPriester = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 59)
    End Sub
    Private Sub Bt_13_10_Urk2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_10_Urk2.Click
        str_Info01 = "Ehe / Urkunde Kirche"
        str_InfoTyp = "A" : If p_str_Komm_EUrk2 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 60)
    End Sub
    Private Sub Bt_13_11_TZ2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_11_TZ2.Click
        str_Info01 = "Ehe / Trauzeugen Kirche"
        str_InfoTyp = "A" : If p_str_Komm_ETZ2 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 61)
    End Sub
    Private Sub Bt_13_12_Dat3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_12_Dat3.Click
        str_Info01 = "Ehe / Datum Scheidung"
        str_InfoTyp = "A" : If p_str_Komm_EDat3 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 62)
    End Sub
    Private Sub Bt_13_13_Urk3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_13_Urk3.Click
        str_Info01 = "Ehe / Urkunde Scheidung"
        str_InfoTyp = "A" : If p_str_Komm_EUrk3 = 0 Then str_InfoTyp = "N"
        Call Read_Info_01(13, 63)
    End Sub

    REM **************************************************************
    REM *  Selektion aus den einzelnen ohne Personen-ID              *
    REM **************************************************************
    Private Sub Dgv_14_Adr_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_14_Adr.CellClick
        int_Adr_Akt = dgv_14_Adr.CurrentRow.Cells(0).Value
        Call Mask_14_Aktiv(True)
        Call Change_Button(True)
        Call TabPos_Mask14()
        Call Mask_Out_14()
        Call Person_Adresse_Zeigen()
    End Sub

    Private Sub Dgv_15_Beruf_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_15_Beruf.CellClick
        int_Adr_Akt = dgv_15_Beruf.CurrentRow.Cells(0).Value
        Call Mask_Out_15()
        Call Person_Beruf_Zeigen()
    End Sub

    REM **************************************************************
    REM *  Selektion aus den einzelnen Grids                         *
    REM **************************************************************
    Private Sub Dgv_Kinder_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Kinder.CellClick
        dbl_Sel_ID = dgv_Kinder.CurrentRow.Cells(0).Value
        dbl_ID = dbl_Sel_ID
        Call Person_Read_01()
    End Sub

    Private Sub Dgv_Geschwister_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Geschwister.CellClick
        dbl_Sel_ID = dgv_Geschwister.CurrentRow.Cells(0).Value
        dbl_ID = dbl_Sel_ID
        Call Person_Read_01()
    End Sub

    Private Sub Dgv_Ehen_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Ehen.CellClick
        dbl_Sel_ID = dgv_Ehen.CurrentRow.Cells(0).Value
        dbl_ID = dbl_Sel_ID
        Call Person_Read_01()
    End Sub

    Private Sub Dgv_11_Paten_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_11_Paten.CellClick
        int_SelCol = e.ColumnIndex
        dbl_Sel_ID = dgv_11_Paten.CurrentRow.Cells(0).Value
        If int_SelCol < 6 Then
            dbl_ID = dbl_Sel_ID
            Call Person_Read_01()
        Else
            REM *--------------------------------------------------------*
            REM *  Sicherheitsabfrage                                    *
            REM *--------------------------------------------------------*
            str_Msg = "Datensatz wirklich löschen?"
            str_Titel = "Löschen Paten"
            style = MsgBoxStyle.DefaultButton2 Or MsgBoxStyle.Critical Or MsgBoxStyle.YesNo
            response = MsgBox(str_Msg, style, str_Titel)
            If response = MsgBoxResult.No Then
                Exit Sub
            End If
            Call Person_Paten_Delete()
            Call Person_Read_01()

        End If
    End Sub
    Private Sub Dgv_13_TZ1_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_13_TZ1.CellClick
        int_SelCol = e.ColumnIndex
        dbl_Sel_ID = dgv_13_TZ1.CurrentRow.Cells(0).Value
        If int_SelCol < 6 Then
            dbl_ID = dbl_Sel_ID
            Call Person_Read_01()
        Else
            REM *--------------------------------------------------------*
            REM *  Sicherheitsabfrage                                    *
            REM *--------------------------------------------------------*
            str_Msg = "Datensatz wirklich löschen?"
            str_Titel = "Löschen Trauzeugen Standesamt"
            style = MsgBoxStyle.DefaultButton2 Or MsgBoxStyle.Critical Or MsgBoxStyle.YesNo
            response = MsgBox(str_Msg, style, str_Titel)
            If response = MsgBoxResult.No Then
                Exit Sub
            End If
            int_TZ_Typ = 8
            Call Person_Trauzeugen_Delete()
            Call Person_Read_01()

        End If
    End Sub
    Private Sub Dgv_13_TZ2_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_13_TZ2.CellClick
        int_SelCol = e.ColumnIndex
        If int_SelCol < 6 Then
            dbl_Sel_ID = dgv_13_TZ2.CurrentRow.Cells(0).Value
            dbl_ID = dbl_Sel_ID
            Call Person_Read_01()
        Else
            REM *--------------------------------------------------------*
            REM *  Sicherheitsabfrage                                    *
            REM *--------------------------------------------------------*
            str_Msg = "Datensatz wirklich löschen?"
            str_Titel = "Löschen Trauzeugen Kirche"
            style = MsgBoxStyle.DefaultButton2 Or MsgBoxStyle.Critical Or MsgBoxStyle.YesNo
            response = MsgBox(str_Msg, style, str_Titel)
            If response = MsgBoxResult.No Then
                Exit Sub
            End If
            int_TZ_Typ = 9
            Call Person_Trauzeugen_Delete()
            Call Person_Read_01()
        End If
    End Sub
    Private Sub Dgv_17_Paten_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_17_Paten.CellClick
        dbl_Sel_ID = dgv_17_Paten.CurrentRow.Cells(0).Value
        dbl_ID = dbl_Sel_ID
        Call Person_Read_01()
    End Sub

    Private Sub Dgv_17_Zeugen_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_17_Zeugen.CellClick
        dbl_Sel_ID = dgv_17_Zeugen.CurrentRow.Cells(0).Value
        dbl_ID = dbl_Sel_ID
        Call Person_Read_01()
    End Sub

    REM **************************************************************
    REM *  Personenauswahl als Funktion/Rolle                        *
    REM **************************************************************
    Private Sub Bt_10_Vater_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_Vater.Click
        int_Merk_STyp = 2
        str_Aufgabe = "Anlage Vater"
        Call Maskenwechsel_Search()
    End Sub

    Private Sub Bt_10_Mutter_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_10_Mutter.Click
        int_Merk_STyp = 3
        str_Aufgabe = "Anlage Mutter"
        Call Maskenwechsel_Search()
    End Sub

    Private Sub Bt_11_07_TaufPaten_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_11_07_TaufPaten.Click
        int_Merk_STyp = 4
        str_Aufgabe = "Anlage Taufpate"
        Call Maskenwechsel_Search()
    End Sub

    Private Sub Bt_13_Partner_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_Partner.Click
        int_Merk_STyp = 5
        str_Aufgabe = "Anlage Partner"
        Call Maskenwechsel_Search()
    End Sub

    Private Sub Bt_13_05_TZ1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_05_TZ1.Click
        int_Merk_STyp = 6
        str_Aufgabe = "Anlage Trauzeuge Standesamt"
        Call Maskenwechsel_Search()
    End Sub

    Private Sub Bt_13_11_TZ2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_13_11_TZ2.Click
        int_Merk_STyp = 7
        str_Aufgabe = "Anlage Trauzeuge Kirche"
        Call Maskenwechsel_Search()
    End Sub

    REM **************************************************************
    REM *  Auswahl aus ListBox - Wechsel Ehepartner                  *
    REM **************************************************************
    Private Sub Lby_13_Partner_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lby_13_Partner.SelectedIndexChanged
        int_lby_Pos = Me.lby_13_Partner.SelectedIndex
        If int_lby_Pos >= 0 Then
            p_int_Ehe41 = te_lng_ID(int_lby_Pos)
            Call Mask_Clear_Ehe()
            Call Person_Read_EheDaten()
            Me.tx_13_Partner.Text = p_int_Ehe41.ToString
            Me.lbx_15_Partner.Text = str_EFeld(int_lby_Pos)
            Call Mask_Out_Ehe()
        End If
    End Sub

    Private Sub Rb_01_Daten_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rb_01_Daten.CheckedChanged
        If rb_01_Daten.Checked Then
            Call Bild_Visible(False)
            Me.web_Brs1.Visible = False
            Call Daten_visible(True)
        End If
    End Sub

    Private Sub Rb_01_Pic_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rb_01_Pic.CheckedChanged
        If rb_01_Pic.Checked Then
            Call Bild_Visible(True)
            Call Daten_visible(False)
            Call Tab_Bilder()
            Call Bilder_Load()
        End If
    End Sub
    Private Sub Dgv_Pictures_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv_Pictures.CellContentClick
        int_Para_DB = 2
        Call Bild_Aendern()
    End Sub
    Private Sub Bt_01_PicOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_01_PicOK.Click
        If int_Para_DB = 1 Then Call Bild_Insert()
        If int_Para_DB = 2 Then Call Bild_Update()

        Call Tab_Bilder()
        Call Bilder_Load()
    End Sub
    Private Sub Bt_01_PicDel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_01_PicDel.Click
        REM *--------------------------------------------------------*
        REM *  Sicherheitsabfrage                                    *
        REM *--------------------------------------------------------*
        str_Msg = "Bild wirklich löschen?"
        str_Titel = "Löschen Bilder der Person"
        style = MsgBoxStyle.DefaultButton2 Or MsgBoxStyle.Critical Or MsgBoxStyle.YesNo
        response = MsgBox(str_Msg, style, str_Titel)
        If response = MsgBoxResult.No Then
            Exit Sub
        End If
        Call Bild_Delete()
        File.Delete(str_Path_2)
        Me.pbx_01_01.Image = Nothing
        Call Tab_Bilder()
        Call Bilder_Load()
    End Sub

    Private Sub Tb1_Selected(ByVal sender As Object, ByVal e As TabControlEventArgs) Handles tb1.Selected
        int_Sel_Tab = e.TabPageIndex
        Call Tab_Reiter_Change()
    End Sub
    Private Sub Cbx_11_Konf_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbx_11_Konf.SelectedIndexChanged
        int_Konf = Me.cbx_11_Konf.SelectedIndex
        If int_Konf < 0 Then int_Konf = 0
        Me.cbx_11_Konf.Text = Me.cbx_11_Konf.Items(int_Konf)
    End Sub
    Private Sub Cbx_10_GDat_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbx_10_GDat.SelectedIndexChanged
        int_GDat_Art = Me.cbx_10_GDat.SelectedIndex
        If int_GDat_Art < 0 Then int_GDat_Art = 0
        str_GDat_Art = Me.cbx_10_GDat.Items(int_GDat_Art)
    End Sub

    Private Sub Cbx_10_SDat_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbx_10_SDat.SelectedIndexChanged
        int_SDat_Art = Me.cbx_10_SDat.SelectedIndex
        If int_SDat_Art < 0 Then int_SDat_Art = 0
        str_SDat_Art = Me.cbx_10_SDat.Items(int_SDat_Art)
    End Sub

    Private Sub Cbx_11_TDat_Art_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbx_11_TDat_Art.SelectedIndexChanged
        int_TDat_Art = Me.cbx_11_TDat_Art.SelectedIndex
        If int_TDat_Art < 0 Then int_TDat_Art = 0
        str_TDat_Art = Me.cbx_11_TDat_Art.Items(int_TDat_Art)
    End Sub

    Private Sub Cbx_11_FDat_Art_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbx_11_FDat_Art.SelectedIndexChanged
        int_FDat_Art = Me.cbx_11_FDat_Art.SelectedIndex
        If int_FDat_Art < 0 Then int_FDat_Art = 0
        str_FDat_Art = Me.cbx_11_FDat_Art.Items(int_FDat_Art)
    End Sub

    Private Sub Cbx_12_BDat_Art_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbx_12_BDat_Art.SelectedIndexChanged
        int_BDat_Art = Me.cbx_12_BDat_Art.SelectedIndex
        If int_BDat_Art < 0 Then int_BDat_Art = 0
        str_BDat_Art = Me.cbx_12_BDat_Art.Items(int_BDat_Art)
    End Sub

    Private Sub Cbx_13_EDat1_Art_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbx_13_EDat1_Art.SelectedIndexChanged
        int_EDat1_Art = Me.cbx_13_EDat1_Art.SelectedIndex
        If int_EDat1_Art < 0 Then int_EDat1_Art = 0
        str_EDat1_Art = Me.cbx_13_EDat1_Art.Items(int_EDat1_Art)
    End Sub

    Private Sub Cbx_13_EDat2_Art_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbx_13_EDat2_Art.SelectedIndexChanged
        int_EDat2_Art = Me.cbx_13_EDat2_Art.SelectedIndex
        If int_EDat2_Art < 0 Then int_EDat2_Art = 0
        str_EDat2_Art = Me.cbx_13_EDat2_Art.Items(int_EDat2_Art)
    End Sub

    Private Sub Cbx_13_EDat3_Art_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbx_13_EDat3_Art.SelectedIndexChanged
        int_EDat3_Art = Me.cbx_13_EDat3_Art.SelectedIndex
        If int_EDat3_Art < 0 Then int_EDat3_Art = 0
        str_EDat3_Art = Me.cbx_13_EDat3_Art.Items(int_EDat3_Art)
    End Sub

    REM **************************************************************
    REM *  Focuswechsel bei Datums-Feldern                           *
    REM **************************************************************
    Private Sub Tx_10_GDat_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_GDat_TT.TextChanged
        If Len(Me.tx_10_GDat_TT.Text) = 2 Then
            Me.tx_10_GDat_MM.Focus()
        End If
    End Sub

    Private Sub Tx_10_GDat_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_GDat_MM.TextChanged
        If Len(Me.tx_10_GDat_MM.Text) = 2 Then
            Me.tx_10_GDat_JJ.Focus()
        End If
    End Sub
    Private Sub Tx_10_GDat_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_GDat_JJ.TextChanged
        If Len(Me.tx_10_GDat_JJ.Text) = 4 Then
            Me.cbx_10_GDat.Focus()
        End If
    End Sub
    Private Sub Tx_10_SDat_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_SDat_TT.TextChanged
        If Len(Me.tx_10_SDat_TT.Text) = 2 Then
            Me.tx_10_SDat_MM.Focus()
        End If
    End Sub
    Private Sub Tx_10_SDat_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_SDat_MM.TextChanged
        If Len(Me.tx_10_SDat_MM.Text) = 2 Then
            Me.tx_10_SDat_JJ.Focus()
        End If
    End Sub
    Private Sub Tx_10_SDat_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_SDat_JJ.TextChanged
        If Len(Me.tx_10_SDat_JJ.Text) = 4 Then
            Me.cbx_10_SDat.Focus()
        End If
    End Sub
    Private Sub Tx_11_TDat_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_11_TDat_TT.TextChanged
        If Len(Me.tx_11_TDat_TT.Text) = 2 Then
            Me.tx_11_TDat_MM.Focus()
        End If
    End Sub
    Private Sub Tx_11_TDat_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_11_TDat_MM.TextChanged
        If Len(Me.tx_11_TDat_MM.Text) = 2 Then
            Me.tx_11_TDat_JJ.Focus()
        End If
    End Sub
    Private Sub Tx_11_TDat_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_11_TDat_JJ.TextChanged
        If Len(Me.tx_11_TDat_JJ.Text) = 4 Then
            Me.cbx_11_TDat_Art.Focus()
        End If
    End Sub
    Private Sub Tx_11_FDat_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_11_FDat_TT.TextChanged
        If Len(Me.tx_11_FDat_TT.Text) = 2 Then
            Me.tx_11_FDat_MM.Focus()
        End If
    End Sub

    Private Sub Ttx_11_FDat_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_11_FDat_MM.TextChanged
        If Len(Me.tx_11_FDat_MM.Text) = 2 Then
            Me.tx_11_FDat_JJ.Focus()
        End If
    End Sub

    Private Sub Tx_11_FDat_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_11_FDat_JJ.TextChanged
        If Len(Me.tx_11_FDat_JJ.Text) = 4 Then
            Me.cbx_11_FDat_Art.Focus()
        End If
    End Sub

    Private Sub Tx_12_BDat_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_12_BDat_TT.TextChanged
        If Len(Me.tx_12_BDat_TT.Text) = 2 Then
            Me.tx_12_BDat_MM.Focus()
        End If
    End Sub

    Private Sub Tx_12_BDat_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_12_BDat_MM.TextChanged
        If Len(Me.tx_12_BDat_MM.Text) = 2 Then
            Me.tx_12_BDat_JJ.Focus()
        End If
    End Sub

    Private Sub Tx_12_BDat_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_12_BDat_JJ.TextChanged
        If Len(Me.tx_12_BDat_JJ.Text) = 4 Then
            Me.cbx_12_BDat_Art.Focus()
        End If
    End Sub

    Private Sub Tx_13_Dat1_TT_TextChanged(sender As Object, e As EventArgs) Handles tx_13_Dat1_TT.TextChanged
        If Len(Me.tx_13_Dat1_TT.Text) = 2 Then
            Me.tx_13_Dat1_MM.Focus()
        End If
    End Sub

    Private Sub Tx_13_Dat1_MM_TextChanged(sender As Object, e As EventArgs) Handles tx_13_Dat1_MM.TextChanged
        If Len(Me.tx_13_Dat1_MM.Text) = 2 Then
            Me.tx_13_Dat1_JJ.Focus()
        End If
    End Sub

    Private Sub Tx_13_Dat1_JJ_TextChanged(sender As Object, e As EventArgs) Handles tx_13_Dat1_JJ.TextChanged
        If Len(Me.tx_13_Dat1_JJ.Text) = 4 Then
            Me.cbx_13_EDat1_Art.Focus()
        End If
    End Sub

    Private Sub Tx_13_Dat2_TT_TextChanged(sender As Object, e As EventArgs) Handles tx_13_Dat2_TT.TextChanged
        If Len(Me.tx_13_Dat2_TT.Text) = 2 Then
            Me.tx_13_Dat2_MM.Focus()
        End If
    End Sub

    Private Sub Tx_13_Dat2_MM_TextChanged(sender As Object, e As EventArgs) Handles tx_13_Dat2_MM.TextChanged
        If Len(Me.tx_13_Dat2_MM.Text) = 2 Then
            Me.tx_13_Dat2_JJ.Focus()
        End If
    End Sub

    Private Sub Tx_13_Dat2_JJ_TextChanged(sender As Object, e As EventArgs) Handles tx_13_Dat2_JJ.TextChanged
        If Len(Me.tx_13_Dat2_JJ.Text) = 4 Then
            Me.cbx_13_EDat2_Art.Focus()
        End If
    End Sub

    Private Sub Tx_13_Dat3_TT_TextChanged(sender As Object, e As EventArgs) Handles tx_13_Dat3_TT.TextChanged
        If Len(Me.tx_13_Dat3_TT.Text) = 2 Then
            Me.tx_13_Dat3_MM.Focus()
        End If
    End Sub

    Private Sub Tx_13_Dat3_MM_TextChanged(sender As Object, e As EventArgs) Handles tx_13_Dat3_MM.TextChanged
        If Len(Me.tx_13_Dat3_MM.Text) = 2 Then
            Me.tx_13_Dat3_JJ.Focus()
        End If
    End Sub

    Private Sub Tx_13_Dat3_JJ_TextChanged(sender As Object, e As EventArgs) Handles tx_13_Dat3_JJ.TextChanged
        If Len(Me.tx_13_Dat3_JJ.Text) = 4 Then
            Me.cbx_13_EDat3_Art.Focus()
        End If
    End Sub

    REM **************************************************************
    REM *  Focuswechsel bei Geschlechtsangabe und Zeichenumsetzung   *
    REM **************************************************************
    Private Sub Tx_10_Geschl_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_Geschl.TextChanged
        If Len(Me.tx_10_Geschl.Text) = 1 Then
            Me.tx_10_Geschl.Text = Me.tx_10_Geschl.Text.ToUpper
            Me.tx_10_Vater.Focus()
        End If
    End Sub

    Private Sub Tx_10_Name_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_Name.TextChanged
        Call Change_Button(True)
    End Sub

    Private Sub Tx_10_Name_Lost(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_Name.LostFocus
        If int_Merk_Neu = 0 Then
            If Me.tx_10_GebName.Text = "" Then Me.tx_10_GebName.Text = Me.tx_10_Name.Text
        End If
    End Sub
    Private Sub Tx_10_GOrt_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_GOrt.TextChanged
        Dim str_TX As String = sender.Text
    End Sub

    Private Sub Tx_10_GOrt_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_GOrt.LostFocus
        str_TX_Ort1 = Me.tx_10_GOrt.Text
        str_TX_Ort2 = ""
        str_TX_Ort3 = ""
        Call Orte_Add()
    End Sub

    Private Sub Tx_10_SOrt_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_10_SOrt.LostFocus
        str_TX_Ort1 = Me.tx_10_SOrt.Text
        str_TX_Ort2 = ""
        str_TX_Ort3 = ""
        Call Orte_Add()
    End Sub
    Private Sub Bt_xx_OK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If int_Merk_Neu = 0 Then
            Call Person_Neu()
        End If
    End Sub

    Private Sub Bt_xx_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub
    'Private Sub Tx_00_ID_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
    'Me.AcceptButton = Me.bt_00_ID
    'End Sub


    REM **************************************************************
    REM *  Searchindex Kölner Phonetik neu aufbauen                  *
    REM **************************************************************
    Private Sub Mn_Util_Search_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mn_Util_Search.Click
        Call Update_Search()
    End Sub

    Private Sub Tx_14_Dat1_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_14_Dat1_TT.TextChanged
        If Len(Me.tx_14_Dat1_TT.Text) = 2 Then
            Me.tx_14_Dat1_MM.Focus()
        End If
    End Sub

    Private Sub Tx_14_Dat1_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_14_Dat1_MM.TextChanged
        If Len(Me.tx_14_Dat1_MM.Text) = 2 Then
            Me.tx_14_Dat1_JJ.Focus()
        End If
    End Sub

    Private Sub Tx_14_Dat1_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_14_Dat1_JJ.TextChanged
        If Len(Me.tx_14_Dat1_JJ.Text) = 4 Then
            Me.tx_14_Dat2_TT.Focus()
        End If
    End Sub

    Private Sub Tx_14_Dat2_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_14_Dat2_TT.TextChanged
        If Len(Me.tx_14_Dat2_TT.Text) = 2 Then
            Me.tx_14_Dat2_MM.Focus()
        End If
    End Sub

    Private Sub Tx_14_Dat2_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_14_Dat2_MM.TextChanged
        If Len(Me.tx_14_Dat1_MM.Text) = 2 Then
            Me.tx_14_Dat2_JJ.Focus()
        End If
    End Sub

    Private Sub Tx_14_Dat2_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_14_Dat2_JJ.TextChanged
        If Len(Me.tx_14_Dat2_JJ.Text) = 4 Then
            Me.tx_14_Tel1.Focus()
        End If
    End Sub

    Private Sub Tx_15_Dat1_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_15_Dat1_TT.TextChanged
        If Len(Me.tx_15_Dat1_TT.Text) = 2 Then
            Me.tx_15_Dat1_MM.Focus()
        End If
    End Sub
    Private Sub Tx_15_Dat1_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_15_Dat1_MM.TextChanged
        If Len(Me.tx_15_Dat1_MM.Text) = 2 Then
            Me.tx_15_Dat1_JJ.Focus()
        End If
    End Sub

    Private Sub Tx_15_Dat1_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_15_Dat1_JJ.TextChanged
        If Len(Me.tx_15_Dat1_JJ.Text) = 4 Then
            Me.tx_15_Dat2_TT.Focus()
        End If
    End Sub

    Private Sub Tx_15_Dat2_TT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_15_Dat2_TT.TextChanged
        If Len(Me.tx_15_Dat2_TT.Text) = 2 Then
            Me.tx_15_Dat2_MM.Focus()
        End If
    End Sub
    Private Sub Tx_15_Dat2_MM_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_15_Dat2_MM.TextChanged
        If Len(Me.tx_15_Dat1_MM.Text) = 2 Then
            Me.tx_15_Dat2_JJ.Focus()
        End If
    End Sub
    Private Sub Tx_15_Dat2_JJ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx_15_Dat2_JJ.TextChanged
        If Len(Me.tx_15_Dat2_JJ.Text) = 4 Then
            Me.tx_15_Beruf.Focus()
        End If
    End Sub

    ' ****************************  Menüstrip-Funktionalitäten ***********************************
    ' ****************************  Stufe 1 mit Unterstufen
    Private Sub Mn1_DB_Auswahl_Click(sender As Object, e As EventArgs) Handles mn11_DB_Auswahl1.Click
        NM_Ahnen_DB.Show()
    End Sub

    Private Sub Mn1_DB_Neu_Click(sender As Object, e As EventArgs) Handles mn12_DB_Neu1.Click
        Call DB_Create()
    End Sub

    Private Sub Mn1_Import_Click(sender As Object, e As EventArgs) Handles mn13_Import1.Click

    End Sub

    Private Sub Mn131_ImpGM_Click(sender As Object, e As EventArgs) Handles mn131_ImpGM.Click
        Call Imp_GenMaster()
        Call Person_Read_t01_Basis()

    End Sub
    Private Sub Mn132_Imp_GC_Click(sender As Object, e As EventArgs) Handles mn132_Imp_GC.Click
        Call Imp_GedCom()
    End Sub
    Private Sub Mn1_Export1_Click(sender As Object, e As EventArgs) Handles mn14_Export1.Click

    End Sub

    Private Sub Mn_141_ExpGC_Click(sender As Object, e As EventArgs) Handles mn_141_ExpGC.Click
        Call Exp_GedCom()
    End Sub
    Private Sub Mn1_Drucker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mn1_Drucker.Click
        PrintDialog.ShowDialog()
    End Sub
    Private Sub Mn1_Monitor_Click(sender As Object, e As EventArgs) Handles mn15_Monitor1.Click

    End Sub
    Private Sub Mn16_1_Click(sender As Object, e As EventArgs) Handles mn161_1.Click
        int_Monitor = 1
        Call Mask_Pos()
    End Sub

    Private Sub Mn16_2_Click(sender As Object, e As EventArgs) Handles mn161_2.Click
        int_Monitor = 2
        Call Mask_Pos()
    End Sub
    Private Sub Mn_16_3_Click(sender As Object, e As EventArgs) Handles mn161_3.Click
        int_Monitor = 3
        Call Mask_Pos()
    End Sub
    Private Sub Mn1_Progende1_Click(sender As Object, e As EventArgs) Handles mn19_Progende1.Click
        Call Parameter_Save()
        End
        'End
    End Sub

    ' ****************************  Stufe 2 mit Unterstufen
    Private Sub Mn_Bearbeiten_Click(sender As Object, e As EventArgs) Handles mn2_Bearbeiten.Click

    End Sub
    Private Sub Mn2_Person_Neu_Click(sender As Object, e As EventArgs) Handles mn21_Person_Neu.Click
        Call Person_Neu()
    End Sub
    Private Sub Mn2_Aendern_Click(sender As Object, e As EventArgs) Handles mn22_Aendern.Click

    End Sub
    Private Sub Mn2_Loeschen_Click(sender As Object, e As EventArgs) Handles mn23_Loeschen.Click
        Call Person_Delete()
    End Sub
    Private Sub Mn2_Search_Click(sender As Object, e As EventArgs) Handles mn24_Search.Click
        int_Merk_STyp = 1
        Call Maskenwechsel_Search()
    End Sub
    Private Sub Mn2_Konsistenz_Click(sender As Object, e As EventArgs) Handles mn25_Konsistenz.Click

    End Sub
    ' ****************************  Stufe 3 mit Unterstufen
    Private Sub Mn3_Liste_NF_Click(sender As Object, e As EventArgs) Handles mn31_Liste_NF.Click
        Call Nachfahren()
    End Sub

    Private Sub Mn3_Liste_VF_Click(sender As Object, e As EventArgs) Handles mn32_Liste_VF.Click
        Call Vorfahren()
    End Sub

    ' ****************************  Stufe 4 mit Unterstufen
    Private Sub Mn_Grafik_Click(sender As Object, e As EventArgs) Handles mn4_Grafik.Click

    End Sub

    ' ****************************  Stufe 5 mit Unterstufen

    Private Sub Mn_Aufgaben_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mn5_Aufgaben.Click
        lng_HID = 0
        Call Maskenwechsel_ToDo()
    End Sub

    ' ****************************  Stufe 6 mit Unterstufen
    Private Sub Mn_Util_Click(sender As Object, e As EventArgs) Handles mn6_Util.Click

    End Sub
    Private Sub Mn6_Para_Click(sender As Object, e As EventArgs) Handles mn61_Para.Click
        Call Maskenwechsel_Para()
    End Sub

    Private Sub Mn6_Search_Click(sender As Object, e As EventArgs) Handles mn62_Search.Click
        int_Merk_STyp = 1
        Call Maskenwechsel_Search()
    End Sub
    Private Sub Mn63_Quellen_Click(sender As Object, e As EventArgs) Handles mn63_Quellen.Click
        Me.Cursor = Cursors.WaitCursor
        Call Quellen_Neu()
        Me.Cursor = Cursors.Default
    End Sub
    Private Sub Mn64_QName_Click(sender As Object, e As EventArgs) Handles mn64_QName.Click
        int_QuellMask = 0
        Call Maskenwechsel_Quelle()

    End Sub

    ' ****************************  Stufe 9 mit Unterstufen
    Private Sub Mn_Hilfe_Click(sender As Object, e As EventArgs) Handles mn9_Hilfe.Click

    End Sub

    Private Sub Dgv_Geschwister_CellFormatting(sender As Object, e As DataGridViewCellFormattingEventArgs) Handles dgv_Geschwister.CellFormatting
        With Me.dgv_Geschwister
            If Not .Rows(e.RowIndex).IsNewRow Then
                Dim RowColor As Color
                Select Case .Rows(e.RowIndex).Cells(7).Value
                    Case "F"
                        RowColor = Color.Red
                    Case "M"
                        RowColor = Color.Blue
                    Case ""
                        RowColor = Color.Green
                    Case Else
                        RowColor = Color.Black
                End Select
                .Rows(e.RowIndex).DefaultCellStyle.ForeColor = RowColor
            End If
        End With
    End Sub

    '  ******************* QuellTyp 1 = Geburt kirchlich
    Private Sub Bt_10_QG1_Click(sender As Object, e As EventArgs) Handles bt_10_QG1.Click
        int_QuellenTyp = 1
        Call Quellen()
        lbl_10_IGurk.Text = p_str_Quelle(1)
        Me.Refresh()
    End Sub

    '  ******************* QuellTyp 2 = Geburt Standesamt
    Private Sub Bt_10_QG2_Click(sender As Object, e As EventArgs) Handles bt_10_QG2.Click
        int_QuellenTyp = 2
        Call Quellen()
        lbl_10_IGurk2.Text = p_str_Quelle(2)
        Me.Refresh()
    End Sub

    '  ******************* QuellTyp 3 = Tod kirchlich
    Private Sub Bt_10_QS1_Click(sender As Object, e As EventArgs) Handles bt_10_QS1.Click
        int_QuellenTyp = 3
        Call Quellen()
        lbl_10_ISurk.Text = p_str_Quelle(3)
        Me.Refresh()
    End Sub

    '  ******************* QuellTyp 4 = Tod Standesamt
    Private Sub Bt_10_QS2_Click(sender As Object, e As EventArgs) Handles bt_10_QS2.Click
        int_QuellenTyp = 4
        Call Quellen()
        lbl_10_ISUrk2.Text = p_str_Quelle(4)
        Me.Refresh()
    End Sub

    '  ******************* QuellTyp 5 = Taufe kirchlich
    Private Sub Bt_11_QT1_Click(sender As Object, e As EventArgs) Handles bt_11_QT1.Click
        int_QuellenTyp = 5
        Call Quellen()
        lbl_11_ITUrk.Text = p_str_Quelle(5)
        Me.Refresh()
    End Sub

    '  ******************* QuellTyp 6 = Kommunion kirchlich
    Private Sub Bt_11_QK1_Click(sender As Object, e As EventArgs) Handles bt_11_QK1.Click
        int_QuellenTyp = 6
        Call Quellen()
        lbl_11_IFUrk.Text = p_str_Quelle(6)
        Me.Refresh()
    End Sub

    '  ******************* QuellTyp 7 = Beerdigung kirchlich
    Private Sub Bt_12_QB1_Click(sender As Object, e As EventArgs) Handles bt_12_QB1.Click
        int_QuellenTyp = 7
        Call Quellen()
        lbl_12_ISUrk.Text = p_str_Quelle(7)
        Me.Refresh()
    End Sub

    '  ******************* QuellTyp 8 = Beerdigung Standesamt
    Private Sub Bt_12_QB2_Click(sender As Object, e As EventArgs) Handles bt_12_QB2.Click
        int_QuellenTyp = 8
        lbl_12_ISUrk2.Text = p_str_Quelle(8)
        Call Quellen()
    End Sub
    '  ******************* QuellTyp 9 = Ehe kirchlich
    Private Sub Bt_13_QE1_Click(sender As Object, e As EventArgs) Handles bt_13_QE1.Click
        int_QuellenTyp = 9
        Call Quellen()
        lbl_13_IUrk1.Text = p_str_Quelle(9)
        Me.Refresh()
    End Sub

    '  ******************* QuellTyp 10 = Ehe Standesamt
    Private Sub Bt_13_QE2_Click(sender As Object, e As EventArgs) Handles bt_13_QE2.Click
        int_QuellenTyp = 10
        Call Quellen()
        lbl_13_IUrk2.Text = p_str_Quelle(10)
        Me.Refresh()
    End Sub

    '  ******************* QuellTyp 11 = Scheidung
    Private Sub Bt_13_QS1_Click(sender As Object, e As EventArgs) Handles bt_13_QS1.Click
        int_QuellenTyp = 11
        Call Quellen()
        lbl_13_IUrk3.Text = p_str_Quelle(11)
        Me.Refresh()
    End Sub

    Public Shared Sub Quellen()
        int_QuellMask = 2
        int_QVersion = 1
        Call Maskenwechsel_Quelle()
    End Sub

    Private Sub Tx_10_Vater_Lost(sender As Object, e As EventArgs) Handles tx_10_Vater.LostFocus
        p_int_Vater = Val(Me.tx_10_Vater.Text)
        If p_int_Vater > 0 Then
            Call Person_Read_Vater()
        Else
            v_lng_ID = 0
        End If
        Call Mask_Out_Vater()
    End Sub

    Private Sub Tx_10_Mutter_Lost(sender As Object, e As EventArgs) Handles tx_10_Mutter.LostFocus
        p_int_Mutter = Val(Me.tx_10_Mutter.Text)
        If p_int_Vater > 0 Then
            Call Person_Read_Mutter()
        Else
            m_lng_ID = 0
        End If
        Call Mask_Out_Mutter()
    End Sub

    Private Sub Tx_13_Partner_Lost(sender As Object, e As EventArgs) Handles tx_13_Partner.LostFocus
        int_Merk_STyp = 5
        dbl_Sel_ID = Val(Me.tx_13_Partner.Text)
        Call Plausi_Ehe()
        If int_Merk_Plausi_Search = 1 Then
            Exit Sub
        End If
        Call Person_Ehe_Insert()
        Call Person_Read_01()
    End Sub

    Private Sub Tx_10_GebName_TextChanged(sender As Object, e As EventArgs) Handles tx_10_GebName.TextChanged

    End Sub

    Private Sub Web_Brs1_DocumentCompleted(sender As Object, e As WebBrowserDocumentCompletedEventArgs) Handles web_Brs1.DocumentCompleted

        'If int_Pic_OK = 1 Then
        '    Dim browserWidth As Integer = Me.web_Brs1.Width - 10
        '    Dim browserHeight = Me.web_Brs1.Height - 10
        '    Dim width, heigth As Integer
        '    Dim newWidth, newHeight As Integer
        '    Dim ImageSize() As Integer
        '    Dim el As HtmlElement = Me.web_Brs1.Document.Images(0)
        '    width = CInt(el.GetAttribute("Width"))
        '    Height = CInt(el.GetAttribute("Height"))
        '    'If (heigth > browserHeight OrElse width > browserWidth) And chkResizeImage.checked Then
        '    If (heigth > browserHeight OrElse width > browserWidth) Then
        '        'ImageSize = CalculateDisplaySize(browserWidth, browserHeight, width, heigth)
        '        'newWidth = ImageSize(0)
        '        'newHeight = ImageSize(1)
        '        Me.web_Brs1.Document.Body.SetAttribute("SCROLL", "NO")
        '        Me.web_Brs1.Document.Body.SetAttribute("LEFTMARGIN", "5")
        '        Me.web_Brs1.Document.Body.SetAttribute("TOPMARGIN", "5")
        '        Me.web_Brs1.Document.Body.SetAttribute("BOTTOMMARGIN", "5")
        '    End If
        'End If
        'Me.web_Brs1.Dispose()
    End Sub

    Public Shared Sub Web_Brs1_Navigating(ByVal sender As System.Object, ByVal e As System.Windows.Forms.WebBrowserNavigatingEventArgs) Handles web_Brs1.Navigating

    End Sub

    Private Sub Bt_Pic_Rotation_Click(sender As Object, e As EventArgs) Handles bt_Pic_Rotation.Click
        Img_Pers.RotateFlip(RotateFlipType.Rotate90FlipXY)
        Me.pbx_01_01.Image = Img_Pers
    End Sub

    Private Sub Tx_00_ID_TextChanged_1(sender As Object, e As EventArgs) Handles tx_00_ID.TextChanged
        Me.bt_00_ID = AcceptButton
    End Sub
    Private Sub Tx_00_ID_KeyDown(sender As System.Object, e As KeyEventArgs) Handles tx_00_ID.KeyDown
        If e.KeyCode = Keys.Enter Then
            dbl_ID = Val(Me.tx_00_ID.Text)
            Call Person_Read_01()
        End If
    End Sub
    'Private Sub Tx_00_ID_GotFocus(sender As System.Object, e As KeyEventArgs) Handles tx_00_ID.GotFocus
    ' tx_00_ID.InsertKeyMode.Overwrite
    'End Sub

End Class