﻿Imports System.Data.OleDb
Imports System
Imports System.IO
Imports System.Data.Odbc
Imports System.Data.Common
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Math
Imports NM_Ahnen.Cls_00_Def
Imports NM_Ahnen.Cls_02_DB
Imports NM_Ahnen.Cls_02_DB_Person_Read
Imports NM_Ahnen.Cls_10_Mask
Imports NM_Ahnen.Cls_90_Mask_Quelle

Public Class NM_Ahnen_Quelle
    Private Sub NM_Ahnen_Quelle_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Call Mask_Pos_Quelle()
        Call Listbox1_Fuellen()
        Me.lbx_t33.Visible = False
        Me.lbx_E33.Visible = False
        Me.cbx_t33_Detail.Visible = False
        Me.lbl_t33_Detail.Visible = False
        Me.lbl_t33_Head.Visible = False

        If int_QuellMask = 0 Then
            Me.bt_Q_OK.Visible = False
            Me.bt_Q_Cancel.Visible = False
            Me.bt_Q_Del.Visible = False
            Me.bt_QGo.Visible = True
            Me.bt_QEnd.Visible = True
        End If

        Me.lbl_3x_QTyp.Text = "Ereignis: " + str_QuellenTyp(int_QuellenTyp)

        If int_QuellenTyp = 1 Then Me.lbl_3x_Event.Text = p_str_GUrk
        If int_QuellenTyp = 2 Then Me.lbl_3x_Event.Text = p_str_GUrk2
        If int_QuellenTyp = 3 Then Me.lbl_3x_Event.Text = p_str_SUrk
        If int_QuellenTyp = 4 Then Me.lbl_3x_Event.Text = p_str_SUrk2
        If int_QuellenTyp = 5 Then Me.lbl_3x_Event.Text = p_str_TUrk
        If int_QuellenTyp = 6 Then Me.lbl_3x_Event.Text = p_str_FUrk
        If int_QuellenTyp = 7 Then Me.lbl_3x_Event.Text = p_str_BUrk1
        If int_QuellenTyp = 8 Then Me.lbl_3x_Event.Text = p_str_BUrk2
        Me.lbl_3x_Event.Text = p_str_Quelle(int_QuellenTyp)
        If int_Event_OK(int_QuellenTyp) = 0 Then
            Me.tx_3x_Datum.Text = str_AktDatP
            Me.tx_3x_Bem.Text = ""
        Else
            Call Quellen_Read()
            Me.tx_3x_Detail.Text = p_str_Detail
            Me.tx_3x_Datum.Text = p_str_DatQ
            Me.tx_3x_Bem.Text = p_str_Bem
            Me.bt_Q_Del.Visible = True
        End If
        int_Sel_t31 = -1
        int_Sel_t32 = -1
        int_Sel_t33 = -1
        Me.tb_Quelle.SelectTab(int_QuellMask)
        Me.tb_Quelle.Show()

    End Sub
    Private Sub Cbx_t31_Bez_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cbx_t31_Bez.SelectedIndexChanged
        str_Sel31_Bez = cbx_t31_Bez.SelectedItem
        Call Pos_Tab_Ermitteln31()
    End Sub

    Private Sub Dgv_Q1_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgv_Q1.CellContentClick
        str_Sel31_Bez = dgv_Q1.CurrentRow.Cells(0).Value
        Call Pos_Tab_Ermitteln31()
    End Sub
    Private Sub Lbx_E31_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lbx_E31.SelectedIndexChanged
        str_Sel31_Bez = lbx_E31.SelectedItem
        Call Pos_Tab_Ermitteln31()
    End Sub

    Private Sub Cbx_t32_Ort_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cbx_t32_Ort.SelectedIndexChanged
        Call Pos_Tab_Ermitteln32()
    End Sub
    Private Sub Lbx_t32_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lbx_t32.SelectedIndexChanged
        str_Sel32_Bez = lbx_t32.SelectedItem
        Call Pos_Tab_Ermitteln32()
    End Sub
    Private Sub Lbx_E32_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lbx_E32.SelectedIndexChanged
        str_Sel32_Bez = lbx_E32.SelectedItem
        Call Pos_Tab_Ermitteln32()
    End Sub

    Private Sub Cbx_t33_Detail_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cbx_t33_Detail.SelectedIndexChanged
        str_Sel33_Bez = cbx_t33_Detail.SelectedItem
        Call Pos_Tab_Ermitteln33()
    End Sub
    Private Sub Lbx_t33_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lbx_t33.SelectedIndexChanged
        str_Sel33_Bez = lbx_t33.SelectedItem
        Call Pos_Tab_Ermitteln33()
    End Sub
    Private Sub Lbx_E33_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lbx_E33.SelectedIndexChanged
        str_Sel33_Bez = lbx_E33.SelectedItem
        Call Pos_Tab_Ermitteln33()
    End Sub

    Private Sub Bt_Q_OK_Click(sender As Object, e As EventArgs) Handles bt_Q_OK.Click
        If int_QuellMask = 2 Then
            If int_Event_OK(int_QuellenTyp) = 1 Then Call Quellen_Update()
            If int_Event_OK(int_QuellenTyp) = 0 Then Call Quellen_Insert()
        End If
        If int_QuellMask = 1 Then
            If int_Sel_t31 < 0 Then Call Quell_Neuanlage31()
            If int_Sel_t31 >= 0 Then
                Call Quell_Update31()
                If int_Sel_t32 < 0 Then Call Quell_Neuanlage32()

                If int_Sel_t32 >= 0 Then
                    Call Quell_Update32()
                    If int_Sel_t33 >= 0 Then
                        Call Quell_Update33()
                    Else
                        Call Quell_Neuanlage33()
                    End If
                End If
            End If
        End If
    End Sub
    Private Sub Bt_Q_Cancel_Click(sender As Object, e As EventArgs) Handles bt_Q_Cancel.Click
        Me.Close()

    End Sub
    Private Sub Listbox1_Fuellen()
        Dim iQ As Integer = 0
        Me.cbx_t31_Bez.Items.Clear()
        For iQ = 1 To int_AnzQ1
            Me.cbx_t31_Bez.Items.Add(str_Q1(iQ))
            Me.lbx_E31.Items.Add(str_Q1(iQ))
            With dgv_Q1.Rows
                .Add(str_Q1(iQ), str_Q1K(iQ))
            End With
        Next
        cbx_t31_Bez.Sorted = True
        Me.lbx_E31.Sorted = True
    End Sub

    Private Sub Pos_Tab_Ermitteln31()
        Me.lbx_t32.Items.Clear()
        Me.lbx_E32.Items.Clear()
        Me.lbx_t33.Items.Clear()
        Me.lbx_E33.Items.Clear()

        For i33 = 0 To int_AnzQ1
            If str_Q1(i33) = str_Sel31_Bez Then
                int_Sel_t31 = i33
                str_Sel_Kurz = str_Q1K(i33)
                tx_QN1_Bez.Text = str_Sel31_Bez
                tx_QN1_Kurz.Text = str_Sel_Kurz
                p_str_Q1H = str_Sel31_Bez
                p_str_Q2H = str_Sel_Kurz
                Call Pruef_Stufe3(i33)
                i33 = int_AnzQ1 + 1
            End If
        Next
        Call Auswahl_T32()
        Me.lbx_t32.Sorted = True
        Me.lbx_E32.Sorted = True
    End Sub
    Private Sub Pos_Tab_Ermitteln32()
        Me.lbx_t33.Items.Clear()
        Me.lbx_E33.Items.Clear()
        If int_Sel_t31 > 0 Then
            For i33 = 0 To int_AnzQ2
                If str_Q2(i33) = str_Sel32_Bez And int_Q2_Typ(i33) = int_Sel_t31 Then
                    int_Sel_t32 = i33
                    int_t13_Ort = i33
                    str_Sel_Ort = str_Q2(i33)
                    tx_QN2_Bez.Text = str_Sel_Ort
                    p_str_Q3H = str_Sel_Ort
                    'p_str_Q4H = str_Sel_Kurz
                    i33 = int_AnzQ2 + 1
                End If
            Next
        End If
        Call Auswahl_T33()
        Me.lbx_t33.Sorted = True
        Me.lbx_E33.Sorted = True
        str_Quelltext = str_Sel_Kurz & "/ " & str_Sel_Ort
        Me.lbl_3x_Neu.Text = str_Quelltext

    End Sub
    Private Sub Pos_Tab_Ermitteln33()
        If int_Sel_t32 > 0 Then
            For i33 = 0 To int_AnzQ3
                If str_Q3(i33) = str_Sel33_Bez Then
                    If int_Q3_Ort(i33) = int_Sel_t32 Then
                        int_Sel_t33 = i33
                        str_Sel_Detail = str_Q3(i33)
                        tx_QN3_Bez.Text = str_Sel_Detail
                        p_str_Q5H = str_Sel_Detail
                        'p_str_Q6H = str_Sel_Kurz
                        i33 = int_AnzQ3 + 1
                    End If
                End If
            Next
        End If
        str_Quelltext = str_Sel_Kurz & "/" & str_Sel_Detail & "/" & str_Sel_Ort
        Me.lbl_3x_Neu.Text = str_Quelltext

    End Sub

    Private Sub Bt_Q_Del_Click(sender As Object, e As EventArgs) Handles bt_Q_Del.Click
        Call Quellen_Delete()
    End Sub

    Private Sub Auswahl_T32()
        Dim int_i9 As Integer
        cbx_t32_Ort.Items.Clear()
        Me.lbx_t32.Items.Clear()
        Me.lbx_E32.Items.Clear()

        For int_i9 = 0 To int_AnzQ2
            If int_Q2_Typ(int_i9) = int_Sel_t31 Then
                Me.cbx_t32_Ort.Items.Add(str_Q2(int_i9))
                Me.lbx_t32.Items.Add(str_Q2(int_i9))
                Me.lbx_E32.Items.Add(str_Q2(int_i9))
            End If
        Next
        cbx_t32_Ort.Sorted = True
        lbx_t32.Sorted = True
        lbx_E32.Sorted = True
    End Sub
    Private Sub Auswahl_T33()
        Dim int_i9 As Integer
        cbx_t33_Detail.Items.Clear()
        lbx_t33.Items.Clear()
        lbx_E33.Items.Clear()

        For int_i9 = 0 To int_AnzQ3
            If int_Q3_Ort(int_i9) = int_Sel_t32 Then
                Me.cbx_t33_Detail.Items.Add(str_Q3(int_i9))
                Me.lbx_t33.Items.Add(str_Q3(int_i9))
                Me.lbx_E33.Items.Add(str_Q3(int_i9))
            End If
        Next
        cbx_t33_Detail.Sorted = True
        lbx_t33.Sorted = True
        lbx_E33.Sorted = True

    End Sub

    Private Sub Quell_Neuanlage31()
        If tx_QN1_Bez.Text > "" Then
            For i31 = 0 To int_AnzQ1
                If str_Q1(i31) = tx_QN1_Bez.Text Then
                    response = MessageBox.Show("Bezeichnung bereits verwendet !", "Info", MessageBoxButtons.OK)
                    tx_QN1_Bez.Text = ""
                    Exit Sub
                End If
            Next
            If tx_QN1_Kurz.Text = "" Then
                response = MessageBox.Show("Kürzel noch erfasssen !", "Info", MessageBoxButtons.OK)
                Exit Sub
            End If

            For i31 = 0 To int_AnzQ1
                If str_Q1(i31) = tx_QN1_Kurz.Text Then
                    response = MessageBox.Show("Kürzel bereits verwendet !", "Info", MessageBoxButtons.OK)
                    Exit Sub
                End If
            Next

            Call DB_Tab_High("t31_ID", "t31_Q1")
            dbl_Max_ID += 1
            str_DBD_t31 = " values ('" + dbl_Max_ID.ToString + "',"
            str_DBD_t31 += "'" + tx_QN1_Bez.Text + "',"
            str_DBD_t31 += "'" + tx_QN1_Kurz.Text + "')"
            str_Tab = str_DBS_t31 + str_DBD_t31
            mySelect.CommandText = "insert into t31_Q1 " & str_Tab
            Call DB_Execute()
            int_Sel_t31 = dbl_Max_ID
            Call Fuellen_Quellen_Q1()
            Call Listbox1_Fuellen()
        End If

    End Sub
    Private Sub Quell_Update31()
        If tx_QN1_Bez.Text = p_str_Q1H And tx_QN1_Kurz.Text = p_str_Q2H Then Exit Sub
        str_Tab = "t31_Bezeichnung = '" + tx_QN1_Bez.Text + "', "
        str_Tab += "t31_Kurz = '" + tx_QN1_Kurz.Text + "'"
        mySelect.CommandText = "update t31_Q1 set " & str_Tab & " where t31_ID = " & int_Sel_t31.ToString
        Call DB_Execute()
    End Sub
    Private Sub Quell_Delete()

    End Sub
    Private Sub Quell_Neuanlage32()
        If tx_QN2_Bez.Text > "" Then
            For i31 = 0 To int_AnzQ2
                If str_Q2(i31) = tx_QN2_Bez.Text And int_Q2_Typ(i31) = int_Sel_t31 Then
                    response = MessageBox.Show("Kombi Bezeichnugn/Ort bereits vorhanden !", "Info", MessageBoxButtons.OK)
                    tx_QN2_Bez.Text = ""
                    Exit Sub
                End If
            Next

            Call DB_Tab_High("t32_ID", "t32_Q2")
            dbl_Max_ID += 1
            Dim intTyp As Integer = int_Sel_t31 + 1
            str_DBD_t32 = " values ('" + dbl_Max_ID.ToString + "',"
            str_DBD_t32 += "'" + intTyp.ToString + "',"
            str_DBD_t32 += "'" + tx_QN2_Bez.Text + "',"
            str_DBD_t32 += "'" + tx_QN2_Bem.Text + "')"
            str_Tab = str_DBS_t32 + str_DBD_t32
            mySelect.CommandText = "insert into t32_Q2 " & str_Tab
            Call DB_Execute()
            int_Sel_t32 = dbl_Max_ID
            Call Fuellen_Quellen_Q2()
            Call Auswahl_T32()
        End If
    End Sub
    Private Sub Quell_Update32()
        If tx_QN2_Bez.Text = p_str_Q3H Then Exit Sub
        str_Tab = "t32_Typ = '" + int_Sel_t31.ToString + "', "
        str_Tab += "t32_Ort = '" + tx_QN2_Bez.Text + "'"
        mySelect.CommandText = "update t32_Q2 set " & str_Tab & " where t32_ID = " & int_Sel_t32.ToString
        Call DB_Execute()

    End Sub
    Private Sub Quell_Neuanlage33()
        If tx_QN3_Bez.Text > "" Then
            For i31 = 0 To int_AnzQ3
                If str_Q3(i31) = tx_QN3_Bez.Text And int_Q3_Ort(i31) = int_Sel_t32 Then
                    response = MessageBox.Show("Kombi Ort/KB bereits vorhanden !", "Info", MessageBoxButtons.OK)
                    tx_QN3_Bez.Text = ""
                    tx_QN3_Bem.Text = ""
                    Exit Sub
                End If
            Next

            Call DB_Tab_High("t33_ID", "t33_Q3")
            dbl_Max_ID += 1
            Dim intOrt As Integer = int_Sel_t32 + 1
            str_DBD_t33 = " values ('" + dbl_Max_ID.ToString + "',"
            str_DBD_t33 += "'" + intOrt.ToString + "',"
            str_DBD_t33 += "'" + tx_QN3_Bez.Text + "',"
            str_DBD_t33 += "'" + tx_QN3_Bem.Text + "')"
            str_Tab = str_DBS_t33 + str_DBD_t33
            mySelect.CommandText = "insert into t33_Q3 " & str_Tab
            Call DB_Execute()
            int_Sel_t32 = dbl_Max_ID
            Call Fuellen_Quellen_Q3()
            Call Auswahl_T33()
        End If
    End Sub
    Private Sub Quell_Update33()
        If tx_QN3_Bez.Text = p_str_Q5H Then Exit Sub
        str_Tab = "t33_Ort = '" + int_Sel_t32.ToString + "', "
        str_Tab += "t33_Detail = '" + tx_QN3_Bez.Text + "'"
        mySelect.CommandText = "update t33_Q3 set " & str_Tab & " where t33_ID = " & int_Sel_t33.ToString
        Call DB_Execute()
    End Sub
    Private Sub Pruef_Stufe3(ByVal in_Help As Integer)
        Dim int_Help As Integer = InStr(1, str_Q1K(in_Help), "KB")
        If int_Help > 0 Then
            Me.gbx_QNeu3.Visible = True
            Me.lbx_t33.Visible = True
            Me.lbx_E33.Visible = True
            Me.cbx_t33_Detail.Visible = True
            Me.lbl_t33_Detail.Visible = True
            Me.lbl_t33_Head.Visible = True

        End If
    End Sub
    Private Sub Tx_EX_Detail_TextChanged(sender As Object, e As EventArgs) Handles tx_3x_Detail.TextChanged
        str_QX4 = tx_3x_Detail.Text
        str_Quelltext = str_Sel_Kurz & "/" & str_Sel_Detail & "/" & str_Sel_Ort & str_QX4
        Me.lbl_3x_Neu.Text = str_Quelltext
    End Sub
    Private Sub Tx_3x_Datum_TextChanged(sender As Object, e As EventArgs) Handles tx_3x_Datum.TextChanged

    End Sub
    Private Sub Tx_3x_Bem_TextChanged(sender As Object, e As EventArgs) Handles tx_3x_Bem.TextChanged
        str_Q_Bemerk = Me.tx_3x_Bem.Text
    End Sub

    Private Sub Tx_QN1_Bez_TextChanged(sender As Object, e As EventArgs) Handles tx_QN1_Bez.TextChanged

    End Sub
    Private Sub Tx_QN1_Kurz_TextChanged(sender As Object, e As EventArgs) Handles tx_QN1_Kurz.TextChanged

    End Sub
    Private Sub Tx_QN2_Bez_TextChanged(sender As Object, e As EventArgs) Handles tx_QN2_Bez.TextChanged

    End Sub
    Private Sub Tx_QN2_Bem_TextChanged(sender As Object, e As EventArgs) Handles tx_QN2_Bem.TextChanged

    End Sub
    Private Sub Tx_QN3_Bez_TextChanged(sender As Object, e As EventArgs) Handles tx_QN3_Bez.TextChanged

    End Sub
    Private Sub Tx_QN3_Bem_TextChanged(sender As Object, e As EventArgs) Handles tx_QN3_Bem.TextChanged

    End Sub
    Private Sub DataGridView1_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgv_OrtName.CellContentClick
        dbl_Sel_ID = dgv_OrtName.CurrentRow.Cells(0).Value
        dbl_ID = dbl_Sel_ID
        Me.Close()
        Call Person_Read_01()
    End Sub

    Private Sub Bt_QGo_Click(sender As Object, e As EventArgs) Handles bt_QGo.Click
        Dim reader As oledbdatareader
        Dim str_Sel As String = " where "
        If int_Sel_t31 < 0 And int_Sel_t32 < 0 And int_Sel_t33 < 0 Then
            response = MessageBox.Show("Keine Auswahl erfolgt !", "Info", MessageBoxButtons.OK)
            Exit Sub
        End If

        If int_Sel_t31 >= 0 Then str_Sel += "t13_Event = " & int_Sel_t31.ToString

        If int_Sel_t32 >= 0 Then
            If int_Sel_t31 >= 0 Then
                str_Sel += " and t13_Ort = " & int_Sel_t32.ToString
            Else
                str_Sel += "t13_Ort = " & int_Sel_t32.ToString
            End If
        End If


        If int_Sel_t33 >= 0 Then
            If int_Sel_t32 >= 0 Then
                str_Sel += " and t13_KB = " & int_Sel_t33.ToString
            Else
                str_Sel = "t13_KB = " & int_Sel_t33.ToString
            End If
        End If


        int_Anz = GetNumberOfRecordsTyp(con, "t13_Quelle", str_Sel)
        Me.Text += " - selektiert: " & int_Anz.ToString

        ReDim int_EVI(int_Anz)
        ReDim int_EV(int_Anz)
        ReDim str_EV(int_Anz)
        ReDim str_ED(int_Anz)
        Dim int_i66 As Integer = 0
        Dim int_i67 As Integer

        mySelect.CommandText = "select * from t13_Quelle " & str_Sel
        reader = mySelect.ExecuteReader
        Do While reader.Read

            int_EVI(int_i66) = Val(reader.Item("t13_ID_t01"))
            int_EV(int_i66) = Val(reader.Item("t13_Typ"))
            myNull = IsDBNull(reader.Item("t13_Datum"))
            If myNull = False Then str_EV(int_i66) = reader.Item("t13_Datum")
            myNull = IsDBNull(reader.Item("t13_Detail"))
            If myNull = False Then str_ED(int_i66) = reader.Item("t13_Detail")
            int_i66 += 1
        Loop
        reader.Close()
        For int_i67 = 0 To (int_i66 - 1)
            dbl_ID = int_EVI(int_i67)
            Call Person_Read_t01_Basis()

            With dgv_OrtName
                .Rows.Add(dbl_ID.ToString("####0"), p_str_Name, p_str_Vorname, str_QuellenTyp(int_EV(int_i67)), str_EV(int_i67), str_ED(int_i67))

            End With
        Next

    End Sub

    Private Sub Bt_QEnd_Click(sender As Object, e As EventArgs) Handles bt_QEnd.Click
        Me.Close()
    End Sub


End Class