﻿Option Explicit On
Option Strict Off
Imports NM_Ahnen.Cls_00_Def
Imports NM_Ahnen

Public Class NM_Ahnen_Sort
    REM ******************************************************************
    REM *  Hauptroutine                                                  *
    REM ******************************************************************
    Private Sub NM_Ahnen_Sort_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If int_Sort_Merk = 0 Then
            Call Sort_Clear()
            int_Sort_Merk = 1
        End If

    End Sub

    Private Sub Tx_Sort_ID_TextChanged(sender As Object, e As EventArgs) Handles Tx_Sort_ID.TextChanged
        If Tx_Sort_ID.Text < "0" Or Tx_Sort_ID.Text > "9" Then
        Else
            int_Sort_Wert(1) = Val(Tx_Sort_ID.Text)
        End If

    End Sub

    Private Sub Tx_Sort_Name_TextChanged(sender As Object, e As EventArgs) Handles Tx_Sort_Name.TextChanged
        If Tx_Sort_Name.Text < "0" Or Tx_Sort_Name.Text > "9" Then
        Else
            int_Sort_Wert(2) = Val(Tx_Sort_Name.Text)
        End If

    End Sub

    Private Sub Tx_Sort_NameZ_TextChanged(sender As Object, e As EventArgs) Handles Tx_Sort_NameZ.TextChanged
        If Tx_Sort_NameZ.Text < "0" Or Tx_Sort_NameZ.Text > "9" Then
        Else
            int_Sort_Wert(3) = Val(Tx_Sort_NameZ.Text)
        End If

    End Sub

    Private Sub Tx_Sort_GebName_TextChanged(sender As Object, e As EventArgs) Handles Tx_Sort_GebName.TextChanged
        If Tx_Sort_GebName.Text < "0" Or Tx_Sort_GebName.Text > "9" Then
        Else
            int_Sort_Wert(4) = Val(Tx_Sort_GebName.Text)
        End If

    End Sub

    Private Sub Tx_Sort_Vorname_TextChanged(sender As Object, e As EventArgs) Handles Tx_Sort_Vorname.TextChanged
        If Tx_Sort_Vorname.Text < "0" Or Tx_Sort_Vorname.Text > "9" Then
        Else
            int_Sort_Wert(5) = Val(Tx_Sort_Vorname.Text)
        End If

    End Sub

    Private Sub Tx_Sort_GebDat_TextChanged(sender As Object, e As EventArgs) Handles Tx_Sort_GebDat.TextChanged
        If Tx_Sort_GebDat.Text < "0" Or Tx_Sort_GebDat.Text > "9" Then
        Else
            int_Sort_Wert(6) = Val(Tx_Sort_GebDat.Text)
        End If

    End Sub

    Private Sub Tx_Sort_GebOrt_TextChanged(sender As Object, e As EventArgs) Handles Tx_Sort_GebOrt.TextChanged
        If Tx_Sort_GebOrt.Text < "0" Or Tx_Sort_GebOrt.Text > "9" Then
        Else
            int_Sort_Wert(7) = Val(Tx_Sort_GebOrt.Text)
        End If

    End Sub

    Private Sub Tx_Sort_StDat_TextChanged(sender As Object, e As EventArgs) Handles Tx_Sort_StDat.TextChanged
        If Tx_Sort_StDat.Text < "0" Or Tx_Sort_StDat.Text > "9" Then
        Else
            int_Sort_Wert(8) = Val(Tx_Sort_StDat.Text)
        End If

    End Sub

    Private Sub Tx_Sort_StOrt_TextChanged(sender As Object, e As EventArgs) Handles Tx_Sort_StOrt.TextChanged
        If Tx_Sort_StOrt.Text < "0" Or Tx_Sort_StOrt.Text > "9" Then
        Else
            int_Sort_Wert(9) = Val(Tx_Sort_StOrt.Text)
        End If

    End Sub
    Private Sub Bt_Sort_OK_Click(sender As Object, e As EventArgs) Handles Bt_Sort_OK.Click
        Call Sort_Clear()
        Call Sort_Plausi()
        If int_Merk_SortError = 1 Then Exit Sub
        Call Sort_String()
        NM_Ahnen_Search.Text = str_Search_Header + str_Sel_Anz + "   /  " + str_Sort_Folge

        myDataSet.Clear()
        mySelect.Connection = con
        mySelect.CommandText = "select * from t91_Person"
        If int_Merk_Where = 1 Then
        End If

        mySelect.CommandText += str_Order

        NM_Ahnen_Search.dgv_91_Tab.ClearSelection()

        myAdapter.SelectCommand = mySelect
        myAdapter.Fill(myDataSet, "t91_Person")
        myDataView = New DataView(myDataSet.Tables("t91_Person"))

        Me.Close()
    End Sub
    Private Sub Bt_Sort_Cancel_Click(sender As Object, e As EventArgs) Handles Bt_Sort_Cancel.Click
        Me.Close()
    End Sub

    Private Sub Bt_Clear_Click(sender As Object, e As EventArgs) Handles Bt_Sort_Clear.Click

        Call Sort_Clear()

    End Sub

    Private Sub Sort_Clear()

        Tx_Sort_ID.Text = ""
        Tx_Sort_Name.Text = ""
        Tx_Sort_NameZ.Text = ""
        Tx_Sort_GebName.Text = ""
        Tx_Sort_Vorname.Text = ""
        Tx_Sort_GebDat.Text = ""
        Tx_Sort_GebOrt.Text = ""
        Tx_Sort_StDat.Text = ""
        Tx_Sort_StOrt.Text = ""

        For i1 = 0 To 9
            int_Sort_ID(i1) = 0
        Next i1

    End Sub
    ' *-----------------------------------------------------------*
    ' *  Sortstring nach Reihenfolge 1-9 zusammensetzen           *
    ' *-----------------------------------------------------------*
    Private Sub Sort_String()
        Dim int_Z5 As Integer = 0
        Dim int_Z6 As Integer = 1
        For i1 = 1 To 9
            For i2 = 1 To 9
                If int_Sort_Wert(i2) = i1 Then
                    int_Sort_ID(i1) = i2
                    i2 = 10
                    int_Z6 += 1
                End If
            Next
        Next

        str_Order = " order by "
        str_Sort_Folge = "Sortierfolge: "
        For i1 = 1 To int_Z6
            If int_Sort_ID(i1) > 0 Then
                If int_Z5 > 0 Then
                    str_Order += ", "
                    str_Sort_Folge += ", "
                End If
                str_Order += str_Sort_Feld(int_Sort_ID(i1))
                str_Sort_Folge += str_Sort_tx(int_Sort_ID(i1))
                int_Z5 += 1
            End If
        Next

    End Sub

    '********************************************************************
    '*   Eingaben auf doppelte Einträge prüfen                          *
    '********************************************************************
    Private Sub Sort_Plausi()

        Dim int_ZSort(9) As Integer
        Dim i3 As Integer

        int_Merk_SortError = 0
        For i1 = 0 To 9
            int_ZSort(i1) = 0
        Next

        For i1 = 1 To 9
            i3 = int_Sort_Wert(i1)
            If i3 > 0 Then int_ZSort(i3) += 1
        Next

        For i1 = 1 To 9
            If int_ZSort(i1) > 1 Then
                MsgBox("Hierachie doppelt vergeben", MsgBoxStyle.OkOnly)
                Exit Sub
                int_Merk_SortError = 1
            End If
        Next

    End Sub

End Class