﻿Imports System.Data.OleDb
Imports System.IO
Imports NM_Ahnen.Cls_00_Def
Imports NM_Ahnen.Cls_02_DB
Imports NM_Ahnen.Cls_04_Util
Imports NM_Ahnen.Cls_20_Blaettern


Class Cls_02_DB_Neu

    REM **************************************************************
    REM *  Laden der Ini-Datei (Pfadangabe)                          *
    REM **************************************************************
    Public Shared Sub DB_Create()

        REM *  bestehende connection schließen      
        con.Close()

        REM *  Datenbankname abfragen und Pfad zusammenbauen
        str_DBName = InputBox("Name der Datenbank eingeben!")
        str_Directory = str_DBPfad1 + "\" + str_DBName
        str_PicDirectory = str_Directory + "\Pic"
        str_DBPfad3 = str_DBPfad1 + "\" + str_DBName + "\" + str_DBName + ".accdb"

        REM *  Directory anlegen
        My.Computer.FileSystem.CreateDirectory(str_Directory)
        My.Computer.FileSystem.CreateDirectory(str_PicDirectory)

        REM * Datenbank anlegen
        Dim catalog As Object
        catalog = CreateObject("ADOX.Catalog")
        catalog.create("Provider=Microsoft.ACE.OLEDB.12.0; Data Source=" + str_DBPfad3)

        dbProv = "Provider=Microsoft.ACE.OLEDB.12.0; Data Source=" + str_DBPfad3 + ";"
        con = New OleDb.OleDbConnection
        con.ConnectionString = dbProv
        mySelect.Connection = con
        con.Open()

        REM *  Tabellen neu anlegen
        Call Tab_Neu_a00()
        Call Tab_Neu_a01()
        Call Tab_Neu_a02()
        Call Tab_Neu_a03()
        Call Tab_Neu_a04()
        Call Tab_Neu_a061()
        Call Tab_Neu_a06()
        Call Tab_Neu_a07()
        Call Tab_Neu_a08()
        Call Tab_Neu_a09()
        Call Tab_Neu_t01()
        Call Tab_Neu_t02()
        Call Tab_Neu_t03()
        Call Tab_Neu_t04()
        Call Tab_Neu_t041()
        Call Tab_Neu_t05()
        Call Tab_Neu_t06()
        Call Tab_Neu_t07()
        Call Tab_Neu_t08()
        Call Tab_Neu_t09()
        Call Tab_Neu_t10()
        Call Tab_Neu_t11()
        Call Tab_Neu_t12()
        Call Tab_Neu_t13()
        Call Tab_Neu_t21()
        Call Tab_Neu_t31()
        Call Tab_Basis_t31()
        Call Tab_Neu_t32()
        Call Tab_Neu_t33()
        Call Tab_Neu_t88()
        Call Tab_Neu_t91()
        Call Tab_Neu_t92()
        Call Tab_Neu_t99()
        con.Close()

        REM *-------------------------------------------------------------------*
        REM *  ini-Datei aktualisieren                                          *
        REM *-------------------------------------------------------------------*
        Dim ze As String
        Dim zeNew As String = ""
        Dim str_Number As String = ""
        Dim str_NMInd As String
        Dim int_ini As Integer = 1
        Dim int_in1 As Integer = 0
        Dim int_in2 As Integer = 0
        Dim int_in3 As Integer = 0
        Dim int_in4 As Integer = 0
        Dim int_in5 As Integer = 0
        Dim int_in6 As Integer = 0

        str_NM99 = ""
        str_ini = "NM_Ahnen.ini"

        Dim fr As New FileStream(str_ini, FileMode.Open)
        Dim sr As New StreamReader(fr)
        REM *  Arbeitstabelle anlegen
        ReDim str_IN1(100)

        REM *  Ermitteln der Datensätze
        Try
            Do Until sr.Peek() = -1
                ze = sr.ReadLine()
                str_NMInd = Mid(ze, 1, 6)
                If str_NMInd = "[NM02]" Or str_NMInd = "[NM03]" Then
                    ze = str_NMInd + "=" + str_DBName
                Else
                    If Mid(ze, 1, 3) = "[N2" And Mid(ze, 6, 2) = "]=" Then
                        int_in3 = Val(Mid(ze, 4, 2))
                        int_in6 = int_in3 + 1
                        str_Number = (int_in6.ToString("00"))
                        int_in2 = int_ini
                        zeNew = "[N2" + str_Number + "]=" + str_DBName
                    End If
                End If
                str_IN1(int_ini) = Mid(ze, 1, Len(ze))
                int_ini += 1

            Loop
            sr.Close()

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

        REM *  Datei neu anlegen und Tabelle einfügen
        Dim fw As New FileStream(str_ini, FileMode.Create)
        Dim sv As New StreamWriter(fw)

        For int_in5 = 1 To int_ini
            ze = str_IN1(int_in5)
            sv.WriteLine(ze)
            If int_in5 = int_in2 Then sv.WriteLine(zeNew)
        Next int_in5
        sv.Close()

        REM *  Neustart mit neu angelegter Datenbank
        If con.State = ConnectionState.Open Then con.Close()

        Call Load_INI()
        Call Open_DB()
        Call Open_Para()
        Call Grundwerte()
        Call Blaettern_First()
        NM_Ahnen.Show()

    End Sub


    REM **************************************************************
    REM *  Anlegen der einzelnen Tabellen der Datenbank              *
    REM *  Felddefinition der Datenbanken                            *
    REM *  Übersetzungen Create-Struktur = Datenbankdefinition       *
    REM *                integer         = long integer              *
    REM *                smallint        = integer                   *
    REM *                varhar          = string Text               *
    REM *                longtext        = Memo                      *
    REM **************************************************************
    Public Shared Sub Tab_Neu_a00()
        Dim sql_a00 As String = "CREATE TABLE a00_Para (" &
            "a00_ID         integer NOT NULL PRIMARY KEY, " &
            "a00_Typ        smallint, " &
            "a00_SubTyp     smallint, " &
            "a00_int1       smallint, " &
            "a00_int2       smallint, " &
            "a00_int3       smallint, " &
            "a00_tx1        varchar(255), " &
            "a00_tx2        varchar(255), " &
            "a00_tx3        varchar(255) " &
            ")"
        Dim cmdT As New OleDbCommand(sql_a00, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_a01()
        Call Tab_Para_Norm()
        dbl_x = 1
        int_Para_Typ = 1
        int_SubTyp = 1
        int_Para_i1 = 1         ' User
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = 1         ' Sprache
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = 0         ' Drucker
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = 0          ' Schrift
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = 1         ' Akt ID
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = 1         ' Monitor   
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = 0         ' Screen
        int_Para_i2 = 0
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = 0         ' Dok.Pfad
        int_Para_i2 = 0
        str_Para_tx1 = "Pic"
        Call Para00_Insert()

    End Sub

    Public Shared Sub Tab_Neu_a02()

        int_Delta_Vater_Min = 15
        int_Delta_Vater_Max = 85
        int_Delta_Mutter_Min = 15
        int_Delta_Mutter_Max = 55
        int_Delta_Ehe_Min = 18
        int_Delta_Ehe_Max = 85
        int_Delta_Pate_Min = 16
        int_Delta_Pate_Max = 85
        int_Delta_Zeuge_Min = 20
        int_Delta_Zeuge_Max = 85

        Call Tab_Para_Norm()
        dbl_x = 9
        int_Para_Typ = 2
        int_SubTyp = 2
        int_Para_i1 = int_Delta_Vater_Min
        int_Para_i2 = int_Delta_Vater_Max
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = int_Delta_Mutter_Min
        int_Para_i2 = int_Delta_Mutter_Max
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = int_Delta_Ehe_Min
        int_Para_i2 = int_Delta_Ehe_Max
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = int_Delta_Pate_Min
        int_Para_i2 = int_Delta_Pate_Max
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        int_Para_i1 = int_Delta_Zeuge_Min
        int_Para_i2 = int_Delta_Zeuge_Max
        Call Para00_Insert()

    End Sub

    Public Shared Sub Tab_Neu_a03()

        Call Tab_Para_Norm()
        dbl_x = 14
        int_Para_Typ = 3
        int_SubTyp = 1
        str_Para_tx1 = "rk"
        str_Para_tx2 = "römisch-katholisch"
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        str_Para_tx1 = "ev"
        str_Para_tx2 = "evangelisch"
        Call Para00_Insert()


        dbl_x += 1
        int_SubTyp += 1
        str_Para_tx1 = "NA"
        str_Para_tx2 = "Neu-Apostolisch"
        Call Para00_Insert()


    End Sub

    Public Shared Sub Tab_Neu_a061()
        Call Tab_Para_Norm()
        dbl_x = 17
        int_Para_Typ = 5
        int_SubTyp = 1
        str_Para_tx1 = "exakt"
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        str_Para_tx1 = "vor"
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        str_Para_tx1 = "nach"
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        str_Para_tx1 = "ca."
        Call Para00_Insert()

        dbl_x += 1
        int_SubTyp += 1
        str_Para_tx1 = "errechnet"
        Call Para00_Insert()

    End Sub

    Public Shared Sub Para00_Insert()
        str_DBD_a00 = " values ('" + dbl_x.ToString + "', "
        str_DBD_a00 += "'" + int_Para_Typ.ToString + "', "
        str_DBD_a00 += "'" + int_SubTyp.ToString + "', "
        str_DBD_a00 += "'" + int_Para_i1.ToString + "', "
        str_DBD_a00 += "'" + int_Para_i2.ToString + "', "
        str_DBD_a00 += "'" + int_Para_i3.ToString + "', "
        str_DBD_a00 += "'" + str_Para_tx1 + "', "
        str_DBD_a00 += "'" + str_Para_tx2 + "', "
        str_DBD_a00 += "'" + str_Para_tx3 + "')"
        str_Tab = str_DBS_a00 + str_DBD_a00

        mySelect.CommandText = "insert into a00_Para " & str_Tab
        Call DB_Execute()

    End Sub
    Public Shared Sub Tab_Basis_t31()
        Dim str_T1 As String
        Dim str_T2 As String

        dbl_x = 0
        str_T1 = "Kirchenbuch"
        str_T2 = "KB"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Staatsarchiv"
        str_T2 = "SA"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "MyHeritage"
        str_T2 = "MyH"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "FamilySearch"
        str_T2 = "FS"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Familienstammbuch"
        str_T2 = "FB"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Ancestry"
        str_T2 = "Anc"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Ortsarchiv"
        str_T2 = "OA"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Internet"
        str_T2 = "IN"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Ahnenpass"
        str_T2 = "AP"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Printobjekt"
        str_T2 = "PRI"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Persönlich"
        str_T2 = "Pers"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Status Animarum"
        str_T2 = "Ani"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Stammbaum"
        str_T2 = "Baum"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Archiv"
        str_T2 = "Arch"
        Call Tab_Neu_t31_Einzel()

        str_T1 = "Archion"
        str_T2 = "AO"
        Call Tab_Neu_t31_Einzel()

    End Sub

    Public Shared Sub Tab_Neu_t31_Einzel()
        dbl_x += 1
        str_DBD_t31 = " values ('" + dbl_x.ToString + "', "
        str_DBD_t31 += "'" + str_t1 + "', "
        str_DBD_t31 += "'" + str_t2 + "')"
        str_Tab = str_DBS_t31 + str_DBD_t31
        mySelect.CommandText = "insert into t31_Q1 " & str_Tab
        Call DB_Execute()

    End Sub

    Public Shared Sub Tab_Neu_a04()
        Dim sql_a04 As String = "CREATE TABLE a04_Orte (" &
            "a04_ID             integer NOT NULL PRIMARY KEY, " &
            "a04_Typ            smallint, " &
            "a04_lfd            smallint, " &
            "a04_Ort1           varchar(50), " &
            "a04_Ort2           varchar(50), " &
            "a04_Ort3           varchar(50), " &
            "a04_Anz0           integer, " &
            "a04_Anz1           integer, " &
            "a04_Anz2           integer, " &
            "a04_Anz3           integer, " &
            "a04_Anz4           integer, " &
            "a04_Anz5           integer, " &
            "a04_Anz6           integer, " &
            "a04_Anz7           integer" &
            ")"
        Dim cmdT As New OleDbCommand(sql_a04, con)
        cmdT.ExecuteNonQuery()

    End Sub
    Public Shared Sub Tab_Neu_a06()
        Dim sql_a06 As String = "CREATE TABLE a06_Beruf (" &
            "a06_ID                integer NOT NULL PRIMARY KEY, " &
            "a06_Beruf             varchar(255), " &
            "a06_Anzahl            integer" &
            ")"
        Dim cmdT As New OleDbCommand(sql_a06, con)
        cmdT.ExecuteNonQuery()

    End Sub
    Public Shared Sub Tab_Neu_a07()
        Dim sql_a07 As String = "CREATE TABLE a07_Namen (" &
            "a07_ID                 integer NOT NULL PRIMARY KEY, " &
            "a07_Text               varchar(80)," &
            "a07_Anz0               integer, " &
            "a07_Anz1               integer, " &
            "a07_Anz2               integer, " &
            "a07_Anz3               integer " &
            ")"
        Dim cmdT As New OleDbCommand(sql_a07, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_a08()
        Dim sql_a08 As String = "CREATE TABLE a08_Tod (" &
            "a08_ID                 integer NOT NULL PRIMARY KEY, " &
            "a08_lfd                smallint, " &
            "a08_Text               varchar(80), " &
            "a08_Anzahl             integer " &
            ")"
        Dim cmdT As New OleDbCommand(sql_a08, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_a09()
        Dim sql_a09 As String = "CREATE TABLE a09_Vornamen (" &
            "a09_ID                integer NOT NULL PRIMARY KEY, " &
            "a09_Text              varchar(80), " &
            "a09_Anzahl            integer " &
            ")"
        Dim cmdT As New OleDbCommand(sql_a09, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Para_Norm()
        int_Para_i1 = 0
        int_Para_i2 = 0
        int_Para_i3 = 0
        str_Para_tx1 = ""
        str_Para_tx2 = ""
        str_Para_tx3 = ""
    End Sub


    Public Shared Sub Tab_Neu_t01()
        Dim sql_t01 As String = "CREATE TABLE t01_Person (" &
            "t01_ID                integer NOT NULL PRIMARY KEY, " &
            "t01_Name              varchar(100), " &
            "t01_GebName           varchar(100), " &
            "t01_NameZ             varchar(100), " &
            "t01_Vorname           varchar(255), " &
            "t01_Rufname           varchar(100), " &
            "t01_SpitzN            varchar(50), " &
            "t01_Titel             varchar(100), " &
            "t01_Geschl            varchar(1), " &
            "t01_Vater             integer, " &
            "t01_Mutter            integer, " &
            "t01_GDat_TT           varchar(2), " &
            "t01_GDat_MM           varchar(2), " &
            "t01_GDat_JJ           varchar(4), " &
            "t01_GDat              varchar(10), " &
            "t01_GDat_Sort         varchar(8), " &
            "t01_GDat_Art          smallint, " &
            "t01_GOrt              varchar(100), " &
            "t01_SDat_TT           varchar(2), " &
            "t01_SDat_MM           varchar(2), " &
            "t01_SDat_JJ           varchar(4), " &
            "t01_SDat              varchar(10), " &
            "t01_SDat_Sort         varchar(8), " &
            "t01_SDat_Art          smallint, " &
            "t01_SOrt              varchar(100), " &
            "t01_Search_Name       varchar(30), " &
            "t01_Search_GebName    varchar(30), " &
            "t01_Search_SpitzN     varchar(30), " &
            "t01_Search_NameZ      varchar(30), " &
            "t01_NeuDat            varchar(8), " &
            "t01_AendDat           varchar(14)" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t01, con)
        cmdT.ExecuteNonQuery()

    End Sub


    Public Shared Sub Tab_Neu_t02()
        Dim sql_t02 As String = "CREATE TABLE t02_Taufe (" &
            "t02_ID                integer NOT NULL PRIMARY KEY, " &
            "t02_Konf              varchar(10), " &
            "t02_TDat_TT           varchar(2), " &
            "t02_TDat_MM           varchar(2), " &
            "t02_TDat_JJ           varchar(4), " &
            "t02_TDat              varchar(10), " &
            "t02_TDat_Art          smallint, " &
            "t02_TOrt              varchar(100), " &
            "t02_Tkirche           varchar(100), " &
            "t02_TPriester         varchar(100), " &
            "t02_FDat_TT           varchar(2), " &
            "t02_FDat_MM           varchar(2), " &
            "t02_FDat_JJ           varchar(4), " &
            "t02_FDat              varchar(10), " &
            "t02_FDat_Art          smallint, " &
            "t02_FOrt              varchar(100), " &
            "t02_Fkirche           varchar(100), " &
            "t02_FPriester         varchar(100), " &
            "t02_Bemerk            longtext" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t02, con)
        cmdT.ExecuteNonQuery()

    End Sub


    Public Shared Sub Tab_Neu_t03()
        Dim sql_t03 As String = "CREATE TABLE t03_Beerd (" &
            "t03_ID                integer NOT NULL PRIMARY KEY, " &
            "t03_BDat_TT           varchar(2), " &
            "t03_BDat_MM           varchar(2), " &
            "t03_BDat_JJ           varchar(4), " &
            "t03_BDat              varchar(10), " &
            "t03_BDat_Art          smallint, " &
            "t03_BOrt              varchar(100), " &
            "t03_BArt              varchar(100), " &
            "t03_BPriester         varchar(100), " &
            "t03_Friedhof          varchar(100), " &
            "t03_Grablage          varchar(100), " &
            "t03_Tod_Ursache       varchar(255), " &
            "t03_Bemerk            longtext" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t03, con)
        cmdT.ExecuteNonQuery()

    End Sub


    Public Shared Sub Tab_Neu_t04()
        Dim sql_t04 As String = "CREATE TABLE t04_Ehe (" &
            "t04_ID                 integer NOT NULL PRIMARY KEY, " &
            "t04_Partner1           integer, " &
            "t04_Partner2           integer, " &
            "t04_FK_ID              integer" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t04, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t041()
        Dim sql_t041 As String = "CREATE TABLE t041_EheDaten (" &
            "t041_ID                integer NOT NULL PRIMARY KEY, " &
            "t041_Dat1_TT           varchar(2), " &
            "t041_Dat1_MM           varchar(2), " &
            "t041_Dat1_JJ           varchar(4), " &
            "t041_Dat1              varchar(10), " &
            "t041_Dat1_Art          smallint, " &
            "t041_Ort1              varchar(100), " &
            "t041_Beamter           varchar(100), " &
            "t041_Dat2_TT           varchar(2), " &
            "t041_Dat2_MM           varchar(2), " &
            "t041_Dat2_JJ           varchar(4), " &
            "t041_Dat2              varchar(10), " &
            "t041_Dat2_Art          smallint, " &
            "t041_Ort2              varchar(100), " &
            "t041_Kirche            varchar(100), " &
            "t041_Priester          varchar(100), " &
            "t041_Dat3_TT           varchar(2), " &
            "t041_Dat3_MM           varchar(2), " &
            "t041_Dat3_JJ           varchar(4), " &
            "t041_Dat3              varchar(10), " &
            "t041_Dat3_Art          smallint, " &
            "t041_Bemerkung         longtext" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t041, con)
        cmdT.ExecuteNonQuery()

    End Sub



    Public Shared Sub Tab_Neu_t05()
        Dim sql_t05 As String = "CREATE TABLE t05_Rolle (" &
            "t05_ID                 integer NOT NULL PRIMARY KEY, " &
            "t05_FK_t01             integer, " &
            "t05_Typ                smallint, " &
            "t05_FK_Rolle           integer" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t05, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t06()
        Dim sql_t06 As String = "CREATE TABLE t06_Adr (" &
            "t06_ID                integer NOT NULL PRIMARY KEY, " &
            "t06_FK_t01            integer, " &
            "t06_Lfd               smallint, " &
            "t06_Land              varchar(25), " &
            "t06_ZIP               varchar(15), " &
            "t06_Ort               varchar(100), " &
            "t06_Strasse           varchar(100), " &
            "t06_Dat_von           varchar(10), " &
            "t06_Dat_bis           varchar(10), " &
            "t06_Telefon1          varchar(30), " &
            "t06_Telefon2          varchar(30), " &
            "t06_Telefax           varchar(30), " &
            "t06_Mail              varchar(100), " &
            "t06_Homepage          varchar(100), " &
            "t06_Komm              longtext" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t06, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t07()
        Dim sql_t07 As String = "CREATE TABLE t07_Beruf (" &
            "t07_ID                integer NOT NULL PRIMARY KEY, " &
            "t07_FK_t01            integer, " &
            "t07_Lfd               smallint, " &
            "t07_Beruf_t77         integer, " &
            "t07_Dat_von           varchar(10), " &
            "t07_Dat_bis           varchar(10), " &
            "t07_Komm              longtext" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t07, con)
        cmdT.ExecuteNonQuery()

    End Sub
    Public Shared Sub Tab_Neu_t08()
        Dim sql_t08 As String = "CREATE TABLE t08_Orte (" &
            "t08_ID                integer NOT NULL PRIMARY KEY, " &
            "t08_a04_t01           integer, " &
            "t08_Event             smallint, " &
            "t08_t01_ID            integer, " &
            "t08_Datum             varchar(8)" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t08, con)
        cmdT.ExecuteNonQuery()

    End Sub


    Public Shared Sub Tab_Neu_t09()
        Dim sql_t09 As String = "CREATE TABLE t09_Bild (" &
            "t09_ID                integer NOT NULL PRIMARY KEY, " &
            "t09_FK_t01            integer, " &
            "t09_lfd               smallint, " &
            "t09_Typ               smallint, " &
            "t09_FileName          varchar(150), " &
            "t09_Text              longtext" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t09, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t10()
        Dim sql_t10 As String = "CREATE TABLE t10_KommNr (" &
            "t10_ID                integer NOT NULL PRIMARY KEY, " &
            "t10_Komm01            varchar(1), " &
            "t10_Komm02            varchar(1), " &
            "t10_Komm03            varchar(1), " &
            "t10_Komm04            varchar(1), " &
            "t10_Komm05            varchar(1), " &
            "t10_Komm06            varchar(1), " &
            "t10_Komm07            varchar(1), " &
            "t10_Komm08            varchar(1), " &
            "t10_Komm09            varchar(1), " &
            "t10_Komm10            varchar(1), " &
            "t10_Komm11            varchar(1), " &
            "t10_Komm12            varchar(1), " &
            "t10_Komm13            varchar(1), " &
            "t10_Komm14            varchar(1), " &
            "t10_Komm15            varchar(1), " &
            "t10_Komm16            varchar(1), " &
            "t10_Komm17            varchar(1), " &
            "t10_Komm18            varchar(1), " &
            "t10_Komm19            varchar(1), " &
            "t10_Komm20            varchar(1), " &
            "t10_Komm21            varchar(1), " &
            "t10_Komm22            varchar(1), " &
            "t10_Komm23            varchar(1), " &
            "t10_Komm24            varchar(1), " &
            "t10_Komm25            varchar(1), " &
            "t10_Komm26            varchar(1), " &
            "t10_Komm27            varchar(1), " &
            "t10_Komm28            varchar(1), " &
            "t10_Komm29            varchar(1), " &
            "t10_Komm30            varchar(1), " &
            "t10_Komm31            varchar(1), " &
            "t10_Komm32            varchar(1), " &
            "t10_Komm33            varchar(1), " &
            "t10_Komm34            varchar(1), " &
            "t10_Komm35            varchar(1), " &
            "t10_Komm36            varchar(1), " &
            "t10_Komm37            varchar(1), " &
            "t10_Komm38            varchar(1), " &
            "t10_Komm39            varchar(1), " &
            "t10_Komm40            varchar(1), " &
            "t10_Komm41            varchar(1), " &
            "t10_Komm42            varchar(1), " &
            "t10_Komm43            varchar(1), " &
            "t10_Komm44            varchar(1), " &
            "t10_Komm45            varchar(1), " &
            "t10_Komm46            varchar(1), " &
            "t10_Komm47            varchar(1), " &
            "t10_Komm48            varchar(1), " &
            "t10_Komm49            varchar(1), " &
            "t10_Komm50            varchar(1), " &
            "t10_Komm51            varchar(1), " &
            "t10_Komm52            varchar(1), " &
            "t10_Komm53            varchar(1), " &
            "t10_Komm54            varchar(1), " &
            "t10_Komm55            varchar(1), " &
            "t10_Komm56            varchar(1), " &
            "t10_Komm57            varchar(1), " &
            "t10_Komm58            varchar(1), " &
            "t10_Komm59            varchar(1), " &
            "t10_Komm60            varchar(1), " &
            "t10_Komm61            varchar(1), " &
            "t10_Komm62            varchar(1), " &
            "t10_Komm63            varchar(1), " &
            "t10_Komm64            varchar(1), " &
           "t10_Komm65            varchar(1)" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t10, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t11()
        Dim sql_t11 As String = "CREATE TABLE t11_Kommentar (" &
            "t11_ID                integer NOT NULL PRIMARY KEY, " &
            "t11_FK_t01            integer, " &
            "t11_Typ               smallint, " &
            "t11_Nummer            smallint, " &
            "t11_Text              longtext" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t11, con)
        cmdT.ExecuteNonQuery()

    End Sub
    Public Shared Sub Tab_Neu_t13()
        Dim sql_t13 As String = "CREATE TABLE t13_Quelle (" &
            "t13_ID      integer NOT NULL PRIMARY KEY, " &
            "t13_ID_t01  integer, " &
            "t13_Art     smallint, " &
            "t13_Typ     smallint, " &
            "t13_Event   smallint, " &
            "t13_Ort     smallint, " &
            "t13_KB      smallint, " &
            "t13_Detail  varchar(50), " &
            "t13_Quelle  varchar(255), " &
            "t13_Datum   varchar(10), " &
            "t13_Bemerkung  varchar(255)" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t13, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t12()
        Dim sql_t12 As String = "CREATE TABLE t12_Text (" &
            "t12_ID                integer NOT NULL PRIMARY KEY, " &
            "t12_Text              LONGTEXT" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t12, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t21()
        Dim sql_t21 As String = "CREATE TABLE t21_Search (" &
            "t21_ID                integer NOT NULL PRIMARY KEY, " &
            "t21_SB                varchar(25), " &
            "t21_FK_t01            integer" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t21, con)
        cmdT.ExecuteNonQuery()

    End Sub
    Public Shared Sub Tab_Neu_t31()
        Dim sql_t31 As String = "CREATE TABLE t31_Q1 (" &
            "t31_ID                integer NOT NULL PRIMARY KEY, " &
            "t31_Bezeichnung       varchar(30), " &
            "t31_Kurz              varchar(5) " &
            ")"
        Dim cmdT As New OleDbCommand(sql_t31, con)
        cmdT.ExecuteNonQuery()

    End Sub
    Public Shared Sub Tab_Neu_t32()
        Dim sql_t32 As String = "CREATE TABLE t32_Q2 (" &
            "t32_ID                integer NOT NULL PRIMARY KEY, " &
            "t32_Typ               smallint, " &
            "t32_Ort               varchar(30), " &
            "t32_Bemerkung         varchar(255) " &
            ")"
        Dim cmdT As New OleDbCommand(sql_t32, con)
        cmdT.ExecuteNonQuery()

    End Sub
    Public Shared Sub Tab_Neu_t33()
        Dim sql_t33 As String = "CREATE TABLE t33_Q3 (" &
            "t33_ID                integer NOT NULL PRIMARY KEY, " &
            "t33_Ort               smallint, " &
            "t33_Detail            varchar(10), " &
            "t33_Bemerkung         varchar(255) " &
            ")"
        Dim cmdT As New OleDbCommand(sql_t33, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t88()
        Dim sql_t88 As String = "CREATE TABLE t88_Historie (" &
            "t88_ID                integer NOT NULL PRIMARY KEY, " &
            "t88_FK_t01            integer, " &
            "t88_Tab               integer, " &
            "t88_Feld              integer, " &
            "t88_Datum             varchar(14), " &
            "t88_Text              longtext" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t88, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t91()
        Dim sql_t01 As String = "CREATE TABLE t91_Person (" &
            "t01_ID                integer NOT NULL PRIMARY KEY, " &
            "t01_Name              varchar(100), " &
            "t01_GebName           varchar(100), " &
            "t01_NameZ             varchar(100), " &
            "t01_Vorname           varchar(255), " &
            "t01_Rufname           varchar(100), " &
            "t01_SpitzN            varchar(50), " &
            "t01_Titel             varchar(100), " &
            "t01_Geschl            varchar(1), " &
            "t01_Vater             integer, " &
            "t01_Mutter            integer, " &
            "t01_GDat_TT           varchar(2), " &
            "t01_GDat_MM           varchar(2), " &
            "t01_GDat_JJ           varchar(4), " &
            "t01_GDat              varchar(10), " &
            "t01_GDat_Sort         varchar(8), " &
            "t01_GDat_Art          smallint, " &
            "t01_GOrt              varchar(100), " &
            "t01_GUrk              varchar(50), " &
            "t01_GUrk2             varchar(50), " &
            "t01_SDat_TT           varchar(2), " &
            "t01_SDat_MM           varchar(2), " &
            "t01_SDat_JJ           varchar(4), " &
            "t01_SDat              varchar(10), " &
            "t01_SDat_Sort         varchar(8), " &
            "t01_SDat_Art          smallint, " &
            "t01_SOrt              varchar(100), " &
            "t01_SUrk              varchar(50), " &
            "t01_SUrk2             varchar(50), " &
            "t01_Search_Name       varchar(20), " &
            "t01_Search_GebName    varchar(20), " &
            "t01_Search_SpitzN     varchar(20), " &
            "t01_Search_NameZ      varchar(20), " &
            "t01_NeuDat            varchar(8), " &
            "t01_AendDat           varchar(8)" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t01, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t92()
        Dim sql_t92 As String = "CREATE TABLE t92_Print (" &
            "t92_ID                integer NOT NULL PRIMARY KEY, " &
            "t92_FK_t01            integer, " &
            "t92_Kekule            smallint, " &
            "t92_Name              varchar(100), " &
            "t92_Vorname           varchar(100), " &
            "t92_Gen_Stufe         smallint, " &
            "t92_GDat              varchar(10), " &
            "t92_SDat              varchar(10), " &
            "t92_Vater             integer, " &
            "t92_Mutter            integer, " &
            "t92_VGrad             varchar(50), " &
            "t92_Partner_ID        integer, " &
            "t92_Geschlecht        varchar(1), " &
            "t92_Res1              varchar(50), " &
            "t92_Res2              varchar(50), " &
            "t92_Res3              varchar(50)" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t92, con)
        cmdT.ExecuteNonQuery()

    End Sub

    Public Shared Sub Tab_Neu_t99()
        Dim sql_t99 As String = "CREATE TABLE t99_Aufgabe (" &
            "t99_ID                integer NOT NULL PRIMARY KEY, " &
            "t99_FK_t01            integer, " &
            "t99_Lfd               integer, " &
            "t99_Name              varchar(100), " &
            "t99_GebName           varchar(100), " &
            "t99_Vorname           varchar(100), " &
            "t99_GDat              varchar(10), " &
            "t99_TabIndex          smallint, " &
            "t99_FeldNr            smallint, " &
            "t99_Aktion            varchar(100)" &
            ")"
        Dim cmdT As New OleDbCommand(sql_t99, con)
        cmdT.ExecuteNonQuery()

    End Sub

End Class
