﻿Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.Cls_90_Mask_201
Public Class Cls_91_DB_Para_06

    REM ***********************************************************************
    REM *  Bearbeitung Parametertabelle a06 (Berufe)                          *
    REM ***********************************************************************
    Public Shared Sub Para_Beruf_Load()
        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Beruf.Rows.Clear()
            For int_i5 = 1 To int_AnzBeruf
                .dgv_Beruf.Rows.Add(int_i5.ToString("0000"), str_Para_Beruf_Text(int_i5))
            Next
            .dgv_Beruf.Columns(1).SortMode = DataGridViewColumnSortMode.Automatic
        End With
    End Sub

    Public Shared Sub Para_Beruf_Neu()
        With NM_Ahnen_Para
            .bt_201_Neu.Enabled = False
            int_AnzBeruf += 1
            .tx_201_Z1.Text = ""
        End With
    End Sub

    Public Shared Sub Para_Beruf_Insert()
        Call DB_Tab_High("a06_ID", "ta06_Beruf")
        dbl_Max_ID += 1
        int_AnzTod += 1
        str_DBD_a06 = " values ('" + dbl_Max_ID.ToString + "',"
        str_DBD_a06 += "'" + NM_Ahnen_Para.tx_201_Z1.Text + "')"
        str_Tab = str_DBS_a06 + str_DBD_a06
        mySelect.CommandText = "insert into a06_Beruf " & str_Tab
        Call DB_Execute()
        Call Tab_Beruf()
        Call Para_Beruf_Load()
    End Sub

    Public Shared Sub Para_Beruf_Update()
        Dim reader As OleDbDataReader
        Dim int_a06_Typ As Integer = 1
        Dim int_i88 As Integer
        With NM_Ahnen_Para
            .tx_201_Z1.Text = .dgv_Beruf.CurrentRow.Cells(1).Value
            For int_i88 = 0 To int_AnzTod
                If .tx_201_Z1.Text = str_Para_Tod_Text(int_i88) Then
                    dbl_x = int_Para_Tod_Nr(int_i88)
                    Exit For
                End If
            Next
        End With
        str_Where = "a06_ID = " + dbl_x.ToString
        mySelect.CommandText = "select * from a06 " & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a06_ID"))
                If myNull = False Then dbl_x = reader.Item("a06_ID")
            Loop
            reader.Close()
        Catch ex As Exception
        End Try
    End Sub
    Public Shared Sub Para_Beruf_Update2()
        str_Tab = "a06_Text = '" + NM_Ahnen_Para.tx_201_Z1.Text + "'"
        mySelect.CommandText = "update a06_Beruf set " & str_Tab & " where a06_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Beruf()
        Call Para_Beruf_Load()
    End Sub

End Class
